package digsec.set.payment.component;
import java.io.*;
import sun.security.util.*;
import java.util.*;


/**
 *	<pre>
 *	1945 InstallRecurData ::= SEQUENCE {
 *	1946    installRecurInd  InstallRecurInd,
 *	1947    irExtensions     [0] MsgExtensions {{IRExtensionsIOS}} OPTIONAL
 *	1948 }
 *	1949
 *	1950 IRExtensionsIOS EXTENSION ::= { ... }
 *	</pre>
 */

public class InstallRecurData implements DerEncoder {

	//field
	public InstallRecurInd installRecurInd;
	
	//Constructor
	public InstallRecurData(InstallRecurInd ins) throws Exception {
		installRecurInd = ins;
	}	

	public InstallRecurData(DerInputStream din) throws Exception {
		DerValue[] adv = din.getSequence(2);	
		installRecurInd = new Recurring(new DerInputStream(adv[0].toByteArray()));
	}

	public void derEncode(OutputStream out) throws IOException {
		DerOutputStream dout = new DerOutputStream();
		installRecurInd.derEncode(dout);
		dout.putNull();
		DerOutputStream dout1 = new DerOutputStream();
		dout1.write((byte)48,dout);
		out.write(dout1.toByteArray());
	}

	public void encode(DerOutputStream dout) throws Exception {
		derEncode(dout);
	}

	public String toString() {
		String s = "<InstallRecurData>";
		s += installRecurInd;
		return s;
	}

	public static void main (String[] args) {
		try {
			Calendar cal = Calendar.getInstance();
			cal.set(1999,11,8);

			Recurring rec = new Recurring(new BigInt(28),
								cal.getTime());
			InstallRecurData install = new InstallRecurData(rec);
			DerOutputStream dout = new DerOutputStream(); 
			System.out.println(install);
			System.out.println("------------encode-------------");
			install.encode(dout);
			install = new InstallRecurData(new DerInputStream(dout.toByteArray()));
			System.out.println(install);
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}
}