package digsec.set.payment.component;
import digsec.set.core.pkcs.*;
import digsec.set.core.crypto.OAEPEncoder;
import sun.security.util.*;
import sun.misc.HexDumpEncoder;
import java.io.*;
import java.util.StringTokenizer;

/**
 *	<pre>
 *	307 PANData0 ::= SEQUENCE {
 *	308    pan         PAN,
 *	309    cardExpiry  CardExpiry,
 *	310    cardSecret  Secret,
 *	311    exNonce     Nonce
 *	312 }
 *	
 *	298 PAN ::= NumericString (SIZE(1..19))
 *	
 *	252 CardExpiry ::= NumericString (SIZE(6)) -- YYYYMM expiration date of card
 *	
 *	296 Nonce ::= OCTET STRING (SIZE(20))
 *	
 *        Secret ::= OCTET STRING (SIZE(1..20))
 */
 
public class PANData0 extends PANData implements DerEncoder, OAEPEncoder {

	public PANData0(String pan, String exp, byte[] secret, byte[] nonce) throws Exception{
		super(pan,exp,secret,nonce);
	}

	public PANData0(DerInputStream din) throws Exception {
		super(din);
	}

}