package digsec.set.payment.component;

/*import sun.security.util.*;
import java.io.*;
import java.security.*;
import java.security.cert.*;
import java.util.*;
*/
import java.io.OutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.math.BigInteger;
import java.lang.Math;	
import java.util.Calendar;
import java.security.PrivateKey;
import java.security.cert.X509Certificate;
import sun.security.x509.X500Name;
import sun.misc.HexDumpEncoder;
import digsec.set.core.pkcs.ContentInfo;
import digsec.set.core.pkcs.AlgorithmId;
import digsec.set.core.crypto.DetachedDigest;
import digsec.set.core.crypto.EX;
import digsec.set.core.crypto.HMAC;
import digsec.set.core.crypto.FalseVerifiedException;

import java.security.*;
import java.security.cert.*;
import java.security.interfaces.*;
import sun.security.util.*;
import javax.crypto.*;
import javax.crypto.spec.*;
import au.net.aba.crypto.provider.*;
import cryptix.provider.Cryptix;


/**
 *	<pre>
 *	PI ::= CHOICE {
 *		piUnsigned		[0] EXPLICIT PIUnsigned,
 *		piDualSigned	[1] EXPLICIT PIDualSigned,
 *		authToken		[2] EXPLICIT AuthToken,
 * 	}
 *	</pre>
 */

public class PI implements DerEncoder {

	//fields
	public PIUnsigned		piUnsigned;
	public PIDualSigned	piDualSigned;
	public AuthToken		authToken;

	public int			flag;

	public static ObjectIdentifier id_set_content_PI = new ObjectIdentifier("2.23.42.0.4");

	//constructor
	public PI(X509Certificate cert, PIOILink pLink, PANToken pToken) throws Exception {
		flag=0;
		piUnsigned = new PIUnsigned(cert,pLink,pToken);
	}

	public PI(X509Certificate cert, PIOILink pLink, PANData pData) throws Exception {
		flag=1;
		piDualSigned = new PIDualSigned(cert,pLink,pData);
	}

	public PI(	PrivateKey 		p1_priv,
			X509Certificate	p1_cert,
			X509Certificate	p2_cert,
			AuthTokenData 	authTokenData,
			PANToken	 	panToken) throws Exception {
		flag=2;
		authToken = new AuthToken(p1_priv,p1_cert,p2_cert,authTokenData,panToken);
	}

	public PI(	PrivateKey privKey, DerInputStream din) throws Exception {
		ContentInfo cInfo = new ContentInfo(din);

		if(!cInfo.getContentType().equals(id_set_content_PI))
			throw new FalseVerifiedException("PI");

		din = new DerInputStream(cInfo.getContent().toByteArray());
		byte flagByte = (byte)din.peekByte();
		DerValue dv = din.getDerValue();
		dv.resetTag((byte)48);
		din = dv.toDerInputStream();

		if(flagByte==(byte)0xA0) {
			flag=0;
			piUnsigned = new PIUnsigned(privKey,din);
		}
		else if(flagByte==(byte)0xA1) {
			flag=1;
			piDualSigned = new PIDualSigned(privKey,din);
		}			
		else if(flagByte==(byte)0xA2) {
			flag=2;
			authToken = new AuthToken(privKey,din);
		}
	}

	public void derEncode(OutputStream out) throws IOException {
		DerOutputStream dout = new DerOutputStream();
		DerOutputStream dout2 = new DerOutputStream();
	
		if(flag==0) {
			piUnsigned.encode(dout);
			dout2.write((byte)0xA0,dout);
		}
		else if(flag==1) {
			piDualSigned.encode(dout);
			dout2.write((byte)0xA1,dout);
		}
		else {
			authToken.encode(dout);
			dout2.write((byte)0xA2,dout);
		}

		ContentInfo cInfo = new ContentInfo(id_set_content_PI,
								new DerValue(dout2.toByteArray()));
		dout.reset();
		cInfo.encode(dout);
		out.write(dout.toByteArray());
	}

	public void encode(DerOutputStream dout) throws IOException {
		derEncode(dout);
	}
	
	public String toString() {
		String s = "<PI>\n";
		if(flag==0)
			s += piUnsigned;
		else if(flag==1)
			s += piDualSigned;
		else
			s += authToken;
		return s;
	}

	public static void main (String[] args) {
		try {
			Security.addProvider(new ABAProvider());
			Security.addProvider(new Cryptix());

			//get payment-gateway's certificate
			InputStream inStream = new FileInputStream("d:\\digsec\\progie\\arif\\source\\digsec\\set\\application\\keystore\\pg.cert");
 			CertificateFactory cf = CertificateFactory.getInstance("X.509");
  			X509Certificate p_cert = (X509Certificate)cf.generateCertificate(inStream);
 			inStream.close();
			
			//get payment-gateway's private key
			inStream = new FileInputStream("d:\\digsec\\progie\\arif\\source\\digsec\\set\\application\\keystore\\pg.jks");
			java.security.KeyStore ks = java.security.KeyStore.getInstance("JKS", "SUN");
			ks.load(inStream,"PaymentGateway".toCharArray());
			PrivateKey p_priv = (PrivateKey) ks.getKey("PG", "PaymentGateway".toCharArray());
/*                   
			byte[] lid_C = {8,1,2,3,1,7};
			TransIDs id = new TransIDs(lid_C,lid_C,"Priharsanta Inc.", "Javanese");
			CurrencyAmount cur = new CurrencyAmount(new BigInt(120),new BigInt(150),    new BigInt(2));  
			Calendar cal = Calendar.getInstance();
			cal.set(1999,11,8);
			Recurring rec = new Recurring(new BigInt(28),
								cal.getTime());
			InstallRecurData install = new InstallRecurData(rec);

			AuthTokenData auth = new AuthTokenData(id,cur,"dodol812",install,
									   new BigInt(1), new Date(), 
									   null);
		
			byte[] ab = {0,1,2,3,4,5,6,7,8,9,0,1,2,3,4,5,6,7,8,9};
			PANToken pToken = new PANToken("1294", "199908", ab);

			PI pi = new PI(p_priv,p_cert,p_cert,auth,pToken);
			System.out.println(pi);

			DerOutputStream dout = new DerOutputStream();
			pi.encode(dout);

			pi = new PI(p_priv,new DerInputStream(dout.toByteArray()));
			System.out.println(pi);
	*/

			//******bikin PANData*************
			byte[] secret = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20};
			byte[] nonce = {0,1,2,3,4,5,6,7,8,9,0,1,2,3,4,5,6,7,8,9};
			PANData panData = new PANData("1294", "199908", secret, nonce);

			//******bikin OIData*******
			FileInputStream fi = new FileInputStream("OIData.dat");
			byte[] input = new byte[fi.available()];
			fi.read(input);
			fi.close();	
			OIData oiData = new OIData(new DerInputStream(input));

			//******bikin PIHead*******
			fi = new FileInputStream("PIHead.dat");
			input = new byte[fi.available()];
			fi.read(input);
			fi.close();
			PIHead piHead = new PIHead(new DerInputStream(input));

			//******bikin PIOILink*******
			PIOILink pioiLink = new PIOILink(piHead, oiData);

			//******bikin PIDualSigned*******
			PI pi = new PI(p_cert, pioiLink, panData);
			System.out.println(pi);

			DerOutputStream dout = new DerOutputStream();
			pi.encode(dout);

			FileOutputStream fo = new FileOutputStream("PIDualSigned.dat");
			fo.write(dout.toByteArray());
			fo.close();

			/*System.out.println("*******der********");
			HexDumpEncoder hde = new HexDumpEncoder();
			System.out.println(hde.encodeBuffer(dout.toByteArray()));
			*/
			System.out.println("\n*******reconstruct********");
			
			fi = new FileInputStream("PIDualSigned.dat");
			input = new byte[fi.available()];
			fi.read(input);
			pi = new PI(p_priv, new DerInputStream(input));
			System.out.println(pi);


		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}
}