package digsec.set.payment.component.SaleDetail;

import java.io.OutputStream;
import java.io.IOException;
import sun.security.util.*;
import sun.misc.HexDumpEncoder;
import digsec.set.payment.component.CurrencyAmount;
import digsec.set.payment.component.Location;

/**
 *	<pre>
 *	3243 AutoCharges ::= SEQUENCE {
 *	3244    regularDistanceCharges  CurrencyAmount,
 *	3245    lateReturnCharges       [ 0] CurrencyAmount  OPTIONAL,
 *	3246    totalDistance           [ 1] Distance  OPTIONAL,
 *	3247    extraDistanceCharges    [ 2] CurrencyAmount  OPTIONAL,
 *	3248    insuranceCharges        [ 3] CurrencyAmount  OPTIONAL,
 *	3249    fuelCharges             [ 4] CurrencyAmount  OPTIONAL,
 *	3250    autoTowingCharges       [ 5] CurrencyAmount  OPTIONAL,
 *	3251    oneWayDropOffCharges    [ 6] CurrencyAmount  OPTIONAL,
 *	3252    telephoneCharges        [ 7] CurrencyAmount  OPTIONAL,
 *	3253    violationsCharges       [ 8] CurrencyAmount  OPTIONAL,
 *	3254    deliveryCharges         [ 9] CurrencyAmount  OPTIONAL,
 *	3255    parkingCharges          [10] CurrencyAmount  OPTIONAL,
 *	3256    otherCharges            [11] CurrencyAmount  OPTIONAL,
 *	3257    totalTaxAmount          [12] CurrencyAmount  OPTIONAL,
 *	3258    auditAdjustment         [13] CurrencyAmount  OPTIONAL
 *	3259 }
 *	</pre>
 */

public class AutoCharges implements DerEncoder {

	private CurrencyAmount regularDistanceCharges;
	private CurrencyAmount lateReturnCharges;
	private Distance totalDistance;
	private CurrencyAmount extraDistanceCharges;
	private CurrencyAmount insuranceCharges;
	private CurrencyAmount fuelCharges;
	private CurrencyAmount autoTowingCharges;
	private CurrencyAmount oneWayDropOffCharges;
	private CurrencyAmount telephoneCharges;
	private CurrencyAmount violationsCharges;
 	private CurrencyAmount deliveryCharges;
	private CurrencyAmount parkingCharges;
	private CurrencyAmount otherCharges;
	private CurrencyAmount totalTaxAmount;
	private CurrencyAmount auditAdjustment;
	private DerValue derNull = new DerValue(DerValue.tag_Null,new byte[0]);

	/**
	 * Constructor for AutoCharges
	 */
	public AutoCharges(CurrencyAmount regularDistanceCharges, CurrencyAmount lateReturnCharges,
		Distance totalDistance, CurrencyAmount extraDistanceCharges, CurrencyAmount insuranceCharges,
		CurrencyAmount fuelCharges, CurrencyAmount autoTowingCharges, CurrencyAmount oneWayDropOffCharges,
		CurrencyAmount telephoneCharges, CurrencyAmount violationsCharges, CurrencyAmount deliveryCharges,
		CurrencyAmount parkingCharges, CurrencyAmount otherCharges,
		CurrencyAmount totalTaxAmount, CurrencyAmount auditAdjustment) throws Exception {

		this.regularDistanceCharges = regularDistanceCharges;
		this.lateReturnCharges = lateReturnCharges;
		this.totalDistance = totalDistance;
		this.extraDistanceCharges = extraDistanceCharges;
		this.insuranceCharges = insuranceCharges;
		this.fuelCharges = fuelCharges;
		this.autoTowingCharges = autoTowingCharges;
		this.oneWayDropOffCharges = oneWayDropOffCharges;
		this.telephoneCharges = telephoneCharges;
		this.violationsCharges = violationsCharges;
		this.deliveryCharges = deliveryCharges;
		this.parkingCharges = parkingCharges;
		this.otherCharges = otherCharges;
		this.totalTaxAmount = totalTaxAmount;
		this.auditAdjustment = auditAdjustment;
	}

	/**
	 * Constructor for AutoCharges
	 * @param din DER representation of AutoCharges
	 */
	public AutoCharges(DerInputStream din) throws IOException {
		DerValue[] adv = din.getSequence(15);

		//isi regularDistanceCharges
		regularDistanceCharges = new CurrencyAmount(new DerInputStream(adv[0].toByteArray()));

		//isi lateReturnCharges
		if (!adv[1].equals(derNull)) {
			adv[1].resetTag(DerValue.tag_Sequence);
			lateReturnCharges = new CurrencyAmount(new DerInputStream(adv[1].toByteArray()));
		}
		else
			lateReturnCharges = null;

		// isi totalDistance
		if (!adv[2].equals(derNull)) {
			adv[2].resetTag(DerValue.tag_Sequence);
			totalDistance = new Distance(new DerInputStream(adv[2].toByteArray()));
		}
		else
			totalDistance = null;

		//isi extraDistanceCharges
		if (!adv[3].equals(derNull)) {
			adv[3].resetTag(DerValue.tag_Sequence);
			extraDistanceCharges = new CurrencyAmount(new DerInputStream(adv[3].toByteArray()));
		}
		else
			extraDistanceCharges = null;

		//isi insuranceCharges
		if (!adv[4].equals(derNull)) {
			adv[4].resetTag(DerValue.tag_Sequence);
			insuranceCharges = new CurrencyAmount(new DerInputStream(adv[4].toByteArray()));
		}
		else
			insuranceCharges = null;

		//isi fuelCharges
		if (!adv[5].equals(derNull)) {
			adv[5].resetTag(DerValue.tag_Sequence);
			fuelCharges = new CurrencyAmount(new DerInputStream(adv[5].toByteArray()));
		}
		else
			fuelCharges = null;

		//isi autoTowingCharges
		if (!adv[6].equals(derNull)) {
			adv[6].resetTag(DerValue.tag_Sequence);
			autoTowingCharges = new CurrencyAmount(new DerInputStream(adv[6].toByteArray()));
		}
		else
			autoTowingCharges = null;

		// isi oneWayDropOffCharges
		if (!adv[7].equals(derNull)) {
			adv[7].resetTag(DerValue.tag_Sequence);
			oneWayDropOffCharges = new CurrencyAmount(new DerInputStream(adv[7].toByteArray()));
		}
		else
			oneWayDropOffCharges = null;

		// isi telephoneCharges
		if (!adv[8].equals(derNull)) {
			adv[8].resetTag(DerValue.tag_Sequence);
			telephoneCharges = new CurrencyAmount(new DerInputStream(adv[8].toByteArray()));
		}
		else
			telephoneCharges = null;

		// isi violationsCharges
		if (!adv[9].equals(derNull)) {
			adv[9].resetTag(DerValue.tag_Sequence);
			violationsCharges = new CurrencyAmount(new DerInputStream(adv[9].toByteArray()));
		}
		else
			violationsCharges = null;

		// isi deliveryCharges
		if (!adv[10].equals(derNull)) {
			adv[10].resetTag(DerValue.tag_Sequence);
			deliveryCharges = new CurrencyAmount(new DerInputStream(adv[10].toByteArray()));
		}
		else
			deliveryCharges = null;

		// isi parkingCharges
		if (!adv[11].equals(derNull)) {
			adv[11].resetTag(DerValue.tag_Sequence);
			parkingCharges = new CurrencyAmount(new DerInputStream(adv[11].toByteArray()));
		}
		else
			parkingCharges = null;

		// isi otherCharges
		if (!adv[12].equals(derNull)) {
			adv[12].resetTag(DerValue.tag_Sequence);
			otherCharges = new CurrencyAmount(new DerInputStream(adv[12].toByteArray()));
		}
		else
			otherCharges = null;

		// isi totalTaxAmount
		if (!adv[13].equals(derNull)) {
			adv[13].resetTag(DerValue.tag_Sequence);
			totalTaxAmount = new CurrencyAmount(new DerInputStream(adv[13].toByteArray()));
		}
		else
			totalTaxAmount = null;

		// isi auditAdjustment
		if (!adv[14].equals(derNull)) {
			adv[14].resetTag(DerValue.tag_Sequence);
			auditAdjustment = new CurrencyAmount(new DerInputStream(adv[14].toByteArray()));
		}
		else
			auditAdjustment = null;
	}

	/**
	* Method for get DER Value
	*
	* @param out OutputStream for storing the result
	*/
	public void derEncode(OutputStream out) throws IOException {
		DerOutputStream dout = new DerOutputStream();
		DerOutputStream midout;

		regularDistanceCharges.encode (dout);

		//kalau lateReturnCharges ada, tulis, kalau tidak, tulis null
		if (lateReturnCharges != null) {
			midout = new DerOutputStream();
			lateReturnCharges.encode (midout);
			dout.writeImplicit((byte)0xA0, midout);
		}
		else
			dout.putNull();

		//kalau totalDistance ada, tulis, kalau tidak, tulis null
		if (totalDistance != null) {
			midout = new DerOutputStream();
			totalDistance.encode (midout);
			dout.writeImplicit((byte)0xA1, midout);
		}
		else
			dout.putNull();

		//kalau extraDistanceCharges ada, tulis, kalau tidak, tulis null
		if (extraDistanceCharges != null) {
			midout = new DerOutputStream();
			extraDistanceCharges.encode (midout);
			dout.writeImplicit((byte)0xA2, midout);
		}
		else
			dout.putNull();

		//kalau insuranceCharges ada, tulis, kalau tidak, tulis null
		if (insuranceCharges != null) {
			midout = new DerOutputStream();
			insuranceCharges.encode (midout);
			dout.writeImplicit((byte)0xA3, midout);
		}
		else
			dout.putNull();

		//kalau fuelCharges ada, tulis, kalau tidak, tulis null
		if (fuelCharges != null) {
			midout = new DerOutputStream();
			fuelCharges.encode (midout);
			dout.writeImplicit((byte)0xA4, midout);
		}
		else
			dout.putNull();

		//kalau autoTowingCharges ada, tulis, kalau tidak, tulis null
		if (autoTowingCharges != null) {
			midout = new DerOutputStream();
			autoTowingCharges.encode (midout);
			dout.writeImplicit((byte)0xA5, midout);
		}
		else
			dout.putNull();

		//kalau oneWayDropOffCharges ada, tulis, kalau tidak, tulis null
		if (oneWayDropOffCharges != null) {
			midout = new DerOutputStream();
			oneWayDropOffCharges.encode (midout);
			dout.writeImplicit((byte)0xA6, midout);
		}
		else
			dout.putNull();

		//kalau telephoneCharges ada, tulis, kalau tidak, tulis null
		if (telephoneCharges != null) {
			midout = new DerOutputStream();
			telephoneCharges.encode (midout);
			dout.writeImplicit((byte)0xA7, midout);
		}
		else
			dout.putNull();

		//kalau violationsCharges ada, tulis, kalau tidak, tulis null
		if (violationsCharges != null) {
			midout = new DerOutputStream();
			violationsCharges.encode (midout);
			dout.writeImplicit((byte)0xA8, midout);
		}
		else
			dout.putNull();

		//kalau deliveryCharges ada, tulis, kalau tidak, tulis null
		if (deliveryCharges != null) {
			midout = new DerOutputStream();
			deliveryCharges.encode (midout);
			dout.writeImplicit((byte)0xA9, midout);
		}
		else
			dout.putNull();

		//kalau parkingCharges ada, tulis, kalau tidak, tulis null
		if (parkingCharges != null) {
			midout = new DerOutputStream();
			parkingCharges.encode (midout);
			dout.writeImplicit((byte)0xAA, midout);
		}
		else
			dout.putNull();

		//kalau otherCharges ada, tulis, kalau tidak, tulis null
		if (otherCharges != null) {
			midout = new DerOutputStream();
			otherCharges.encode (midout);
			dout.writeImplicit((byte)0xAB, midout);
		}
		else
			dout.putNull();

		//kalau totalTaxAmount ada, tulis, kalau tidak, tulis null
		if (totalTaxAmount != null) {
			midout = new DerOutputStream();
			totalTaxAmount.encode (midout);
			dout.writeImplicit((byte)0xAC, midout);
		}
		else
			dout.putNull();

		//kalau auditAdjustment ada, tulis, kalau tidak, tulis null
		if (auditAdjustment != null) {
			midout = new DerOutputStream();
			auditAdjustment.encode (midout);
			dout.writeImplicit((byte)0xAD, midout);
		}
		else
			dout.putNull();

		//tulis tag sequence
		DerOutputStream dout2 = new DerOutputStream();
		dout2.write(DerValue.tag_Sequence,dout);
		out.write(dout2.toByteArray());		//tulis semuanya ke dout
	}		

	/**
	 * Method for get DER Value 
	 *
	 * @param dout DerOutputStream for storing the result
	 */
	public void encode(DerOutputStream dout) throws IOException {
		derEncode(dout);
	}

	/**
	 * Method for get the regularDistanceCharges
	 */
	public CurrencyAmount getRegularDistanceCharges() {
		return regularDistanceCharges;
	}

	/**
	 * Method for get the lateReturnCharges
	 */
	public CurrencyAmount getLateReturnCharges() {
		return lateReturnCharges;
	}

	/**
	 * Method for get the totalDistance
	 */
	public Distance getTotalDistance() {
		return totalDistance;
	}

	/**
	 * Method for get the extraDistanceCharges
	 */
	public CurrencyAmount getExtraDistanceCharges() {
		return extraDistanceCharges;
	}

	/**
	 * Method for get the insuranceCharges
	 */
	public CurrencyAmount getInsuranceCharges() {
		return insuranceCharges;
	}

	/**
	 * Method for get the fuelCharges
	 */
	public CurrencyAmount getFuelCharges() {
		return fuelCharges;
	}

	/**
	 * Method for get the autoTowingCharges
	 */
	public CurrencyAmount getAutoTowingCharges() {
		return autoTowingCharges;
	}

	/**
	 * Method for get the oneWayDropOffCharges
	 */
	public CurrencyAmount getOneWayDropOffCharges() {
		return oneWayDropOffCharges;
	}

	/**
	 * Method for get the telephoneCharges
	 */
	public CurrencyAmount getTelephoneCharges() {
		return telephoneCharges;
	}

	/**
	 * Method for get the violationsCharges
	 */
	public CurrencyAmount getViolationsCharges() {
		return violationsCharges;
	}

	/**
	 * Method for get the deliveryCharges
	 */
	public CurrencyAmount getDeliveryCharges() {
		return deliveryCharges;
	}

	/**
	 * Method for get the parkingCharges
	 */
	public CurrencyAmount getParkingCharges() {
		return parkingCharges;
	}

	/**
	 * Method for get the otherCharges
	 */
	public CurrencyAmount getOtherCharges() {
		return otherCharges;
	}

	/**
	 * Method for get the totalTaxAmount
	 */
	public CurrencyAmount getTotalTaxAmount() {
		return totalTaxAmount;
	}

	/**
	 * Method for get the auditAdjustment
	 */
	public CurrencyAmount getAuditAdjustment() {
		return parkingCharges;
	}

	/**
	 * Method for get the string representation of this object
	 * @return string representation of AutoCharges object
	 */
	public String toString() {
		String s = "";

		s = s + "AutoCharges ::= RegularDistanceCharges : " + regularDistanceCharges + "\n";

		if(lateReturnCharges != null)
			s = s + "AutoCharges ::= LateReturnCharges : " + lateReturnCharges + "\n";

		if(totalDistance != null)
			s = s + "AutoCharges ::= TotalDistance : " + totalDistance + "\n";

		if(extraDistanceCharges != null)
			s = s + "AutoCharges ::= ExtraDistanceCharges : " + extraDistanceCharges + "\n";

		if(insuranceCharges != null)
			s = s + "AutoCharges ::= InsuranceCharges : " + insuranceCharges + "\n";

		if(fuelCharges != null)
			s = s + "AutoCharges ::= FuelCharges : " + fuelCharges + "\n";

		if(autoTowingCharges != null)
			s = s + "AutoCharges ::= AutoTowingCharges : " + autoTowingCharges + "\n";

		if(oneWayDropOffCharges != null)
			s = s + "AutoCharges ::= OneWayDropOffCharges : " + oneWayDropOffCharges + "\n";

		if(telephoneCharges != null)
			s = s + "AutoCharges ::= TelephoneCharges : " + telephoneCharges + "\n";

		if(violationsCharges != null)
			s = s + "AutoCharges ::= ViolationsCharges : " + violationsCharges + "\n";

		if(deliveryCharges != null)
			s = s + "AutoCharges ::= DeliveryCharges : " + deliveryCharges + "\n";

		if(parkingCharges != null)
			s = s + "AutoCharges ::= ParkingCharges : " + parkingCharges + "\n";

		if(otherCharges != null)
			s = s + "AutoCharges ::= OtherCharges : " + otherCharges + "\n";
	
		if(totalTaxAmount != null)
			s = s + "AutoCharges ::= TotalTaxAmount : " + totalTaxAmount + "\n";

		if(auditAdjustment != null)
			s = s + "AutoCharges ::= AuditAdjustment : " + auditAdjustment + "\n";

		return s;
	}

	static void main(String[] args) {
		try 
		{
			CurrencyAmount regularDistanceCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount lateReturnCharges  = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));

			DistanceScale scale = new DistanceScale(new BigInt(1));
			BigInt dist = new BigInt(8);
			Distance totalDistance = new Distance (scale, dist);

			CurrencyAmount extraDistanceCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount insuranceCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount fuelCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount autoTowingCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount oneWayDropOffCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount telephoneCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount violationsCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
		 	CurrencyAmount deliveryCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount parkingCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount otherCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount totalTaxAmount = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount auditAdjustment = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));

			AutoCharges autoCharges = new AutoCharges (regularDistanceCharges,
				lateReturnCharges, totalDistance, extraDistanceCharges,
				insuranceCharges, fuelCharges, autoTowingCharges, oneWayDropOffCharges,
				telephoneCharges, violationsCharges, deliveryCharges, parkingCharges,
				otherCharges, totalTaxAmount, auditAdjustment);
			System.out.println(autoCharges);

			DerOutputStream dout = new DerOutputStream();
			autoCharges.encode(dout);
			HexDumpEncoder hde = new HexDumpEncoder();
			System.out.println(hde.encodeBuffer(dout.toByteArray()));

			System.out.println("*******reconstruct********");
			autoCharges = new AutoCharges (new DerInputStream(dout.toByteArray()));
			System.out.println(autoCharges);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}
