package digsec.set.payment.component.SaleDetail;

import java.io.OutputStream;
import java.io.IOException;
import sun.security.util.*;
import sun.misc.HexDumpEncoder;
import digsec.set.payment.component.CurrencyAmount;
import digsec.set.payment.component.Location;

/**
 *	<pre>
 *	3283 HotelCharges ::= SEQUENCE {
 *	3284    roomCharges            CurrencyAmount,
 *	3285    roomTax                [ 0] CurrencyAmount  OPTIONAL,
 *	3286    prepaidExpenses        [ 1] CurrencyAmount  OPTIONAL,
 *	3287    foodBeverageCharges    [ 2] CurrencyAmount  OPTIONAL,
 *	3288    roomServiceCharges     [ 3] CurrencyAmount  OPTIONAL,
 *	3289    miniBarCharges         [ 4] CurrencyAmount  OPTIONAL,
 *	3290    laundryCharges         [ 5] CurrencyAmount  OPTIONAL,
 *	3291    telephoneCharges       [ 6] CurrencyAmount  OPTIONAL,
 *	3292    businessCenterCharges  [ 7] CurrencyAmount  OPTIONAL,
 *	3293    parkingCharges         [ 8] CurrencyAmount  OPTIONAL,
 *	3294    movieCharges           [ 9] CurrencyAmount  OPTIONAL,
 *	3295    healthClubCharges      [10] CurrencyAmount  OPTIONAL,
 *	3296    giftShopPurchases      [11] CurrencyAmount  OPTIONAL,
 *	3297    folioCashAdvances      [12] CurrencyAmount  OPTIONAL,
 *	3298    otherCharges           [13] CurrencyAmount  OPTIONAL,
 *	3299    totalTaxAmount         [14] CurrencyAmount  OPTIONAL,
 *	3300    auditAdjustment        [15] CurrencyAmount  OPTIONAL
 *	3301 }
 *	</pre>
 */

public class HotelCharges implements DerEncoder {

	private CurrencyAmount roomCharges;
	private CurrencyAmount roomTax;
	private CurrencyAmount prepaidExpenses;
	private CurrencyAmount foodBeverageCharges;
	private CurrencyAmount roomServiceCharges;
	private CurrencyAmount miniBarCharges;
	private CurrencyAmount laundryCharges;
	private CurrencyAmount telephoneCharges;
	private CurrencyAmount businessCenterCharges;
	private CurrencyAmount parkingCharges;
 	private CurrencyAmount movieCharges;
	private CurrencyAmount healthClubCharges;
	private CurrencyAmount giftShopPurchases;
	private CurrencyAmount folioCashAdvances;
	private CurrencyAmount otherCharges;
	private CurrencyAmount totalTaxAmount;
	private CurrencyAmount auditAdjustment;
	private DerValue derNull = new DerValue(DerValue.tag_Null,new byte[0]);

	/**
	 * Constructor for HotelCharges
	 */
	public HotelCharges(CurrencyAmount roomCharges, CurrencyAmount roomTax,
		CurrencyAmount prepaidExpenses, CurrencyAmount foodBeverageCharges, CurrencyAmount roomServiceCharges,
		CurrencyAmount miniBarCharges, CurrencyAmount laundryCharges, CurrencyAmount telephoneCharges,
		CurrencyAmount businessCenterCharges, CurrencyAmount parkingCharges, CurrencyAmount movieCharges,
		CurrencyAmount healthClubCharges, CurrencyAmount giftShopPurchases, CurrencyAmount folioCashAdvances,
		CurrencyAmount otherCharges, CurrencyAmount totalTaxAmount,
		CurrencyAmount auditAdjustment) throws Exception {

		this.roomCharges = roomCharges;
		this.roomTax = roomTax;
		this.prepaidExpenses = prepaidExpenses;
		this.foodBeverageCharges = foodBeverageCharges;
		this.roomServiceCharges = roomServiceCharges;
		this.miniBarCharges = miniBarCharges;
		this.laundryCharges = laundryCharges;
		this.telephoneCharges = telephoneCharges;
		this.businessCenterCharges = businessCenterCharges;
		this.parkingCharges = parkingCharges;
		this.movieCharges = movieCharges;
		this.healthClubCharges = healthClubCharges;
		this.giftShopPurchases = giftShopPurchases;
		this.folioCashAdvances = folioCashAdvances;
		this.otherCharges = otherCharges;
		this.totalTaxAmount = totalTaxAmount;
		this.auditAdjustment = auditAdjustment;
	}

	/**
	 * Constructor for HotelCharges
	 * @param din DER representation of HotelCharges
	 */
	public HotelCharges(DerInputStream din) throws IOException {
		DerValue[] adv = din.getSequence(17);

		//isi roomCharges
		roomCharges = new CurrencyAmount(new DerInputStream(adv[0].toByteArray()));

		//isi roomTax
		if (!adv[1].equals(derNull)) {
			adv[1].resetTag(DerValue.tag_Sequence);
			roomTax = new CurrencyAmount(new DerInputStream(adv[1].toByteArray()));
		}
		else
			roomTax = null;

		// isi prepaidExpenses
		if (!adv[2].equals(derNull)) {
			adv[2].resetTag(DerValue.tag_Sequence);
			prepaidExpenses = new CurrencyAmount(new DerInputStream(adv[2].toByteArray()));
		}
		else
			prepaidExpenses = null;

		//isi foodBeverageCharges
		if (!adv[3].equals(derNull)) {
			adv[3].resetTag(DerValue.tag_Sequence);
			foodBeverageCharges = new CurrencyAmount(new DerInputStream(adv[3].toByteArray()));
		}
		else
			foodBeverageCharges = null;

		//isi roomServiceCharges
		if (!adv[4].equals(derNull)) {
			adv[4].resetTag(DerValue.tag_Sequence);
			roomServiceCharges = new CurrencyAmount(new DerInputStream(adv[4].toByteArray()));
		}
		else
			roomServiceCharges = null;

		//isi miniBarCharges
		if (!adv[5].equals(derNull)) {
			adv[5].resetTag(DerValue.tag_Sequence);
			miniBarCharges = new CurrencyAmount(new DerInputStream(adv[5].toByteArray()));
		}
		else
			miniBarCharges = null;

		//isi laundryCharges
		if (!adv[6].equals(derNull)) {
			adv[6].resetTag(DerValue.tag_Sequence);
			laundryCharges = new CurrencyAmount(new DerInputStream(adv[6].toByteArray()));
		}
		else
			laundryCharges = null;

		// isi telephoneCharges
		if (!adv[7].equals(derNull)) {
			adv[7].resetTag(DerValue.tag_Sequence);
			telephoneCharges = new CurrencyAmount(new DerInputStream(adv[7].toByteArray()));
		}
		else
			telephoneCharges = null;

		// isi businessCenterCharges
		if (!adv[8].equals(derNull)) {
			adv[8].resetTag(DerValue.tag_Sequence);
			businessCenterCharges = new CurrencyAmount(new DerInputStream(adv[8].toByteArray()));
		}
		else
			businessCenterCharges = null;

		// isi parkingCharges
		if (!adv[9].equals(derNull)) {
			adv[9].resetTag(DerValue.tag_Sequence);
			parkingCharges = new CurrencyAmount(new DerInputStream(adv[9].toByteArray()));
		}
		else
			parkingCharges = null;

		// isi movieCharges
		if (!adv[10].equals(derNull)) {
			adv[10].resetTag(DerValue.tag_Sequence);
			movieCharges = new CurrencyAmount(new DerInputStream(adv[10].toByteArray()));
		}
		else
			movieCharges = null;

		// isi healthClubCharges
		if (!adv[11].equals(derNull)) {
			adv[11].resetTag(DerValue.tag_Sequence);
			healthClubCharges = new CurrencyAmount(new DerInputStream(adv[11].toByteArray()));
		}
		else
			healthClubCharges = null;

		// isi giftShopPurchases
		if (!adv[12].equals(derNull)) {
			adv[12].resetTag(DerValue.tag_Sequence);
			giftShopPurchases = new CurrencyAmount(new DerInputStream(adv[12].toByteArray()));
		}
		else
			giftShopPurchases = null;

		// isi folioCashAdvances
		if (!adv[13].equals(derNull)) {
			adv[13].resetTag(DerValue.tag_Sequence);
			folioCashAdvances = new CurrencyAmount(new DerInputStream(adv[13].toByteArray()));
		}
		else
			folioCashAdvances = null;

		// isi otherCharges
		if (!adv[14].equals(derNull)) {
			adv[14].resetTag(DerValue.tag_Sequence);
			otherCharges = new CurrencyAmount(new DerInputStream(adv[14].toByteArray()));
		}
		else
			otherCharges = null;

		// isi totalTaxAmount
		if (!adv[15].equals(derNull)) {
			adv[15].resetTag(DerValue.tag_Sequence);
			totalTaxAmount = new CurrencyAmount(new DerInputStream(adv[15].toByteArray()));
		}
		else

			totalTaxAmount = null;

		// isi auditAdjustment
		if (!adv[16].equals(derNull)) {
			adv[16].resetTag(DerValue.tag_Sequence);
			auditAdjustment = new CurrencyAmount(new DerInputStream(adv[16].toByteArray()));
		}
		else
			auditAdjustment = null;
	}

	/**
	* Method for get DER Value
	*
	* @param out OutputStream for storing the result
	*/
	public void derEncode(OutputStream out) throws IOException {
		DerOutputStream dout = new DerOutputStream();
		DerOutputStream midout;

		roomCharges.encode (dout);

		//kalau roomTax ada, tulis, kalau tidak, tulis null
		if (roomTax != null) {
			midout = new DerOutputStream();
			roomTax.encode (midout);
			dout.writeImplicit((byte)0xA0, midout);
		}
		else
			dout.putNull();
 
		//kalau prepaidExpenses ada, tulis, kalau tidak, tulis null
		if (prepaidExpenses != null) {
			midout = new DerOutputStream();
			prepaidExpenses.encode (midout);
			dout.writeImplicit((byte)0xA1, midout);
		}
		else
			dout.putNull();

		//kalau foodBeverageCharges ada, tulis, kalau tidak, tulis null
		if (foodBeverageCharges != null) {
			midout = new DerOutputStream();
			foodBeverageCharges.encode (midout);
			dout.writeImplicit((byte)0xA2, midout);
		}
		else
			dout.putNull();

		//kalau roomServiceCharges ada, tulis, kalau tidak, tulis null
		if (roomServiceCharges != null) {
			midout = new DerOutputStream();
			roomServiceCharges.encode (midout);
			dout.writeImplicit((byte)0xA3, midout);
		}
		else
			dout.putNull();

		//kalau miniBarCharges ada, tulis, kalau tidak, tulis null
		if (miniBarCharges != null) {
			midout = new DerOutputStream();
			miniBarCharges.encode (midout);
			dout.writeImplicit((byte)0xA4, midout);
		}
		else
			dout.putNull();

		//kalau laundryCharges ada, tulis, kalau tidak, tulis null
		if (laundryCharges != null) {
			midout = new DerOutputStream();
			laundryCharges.encode (midout);
			dout.writeImplicit((byte)0xA5, midout);
		}
		else
			dout.putNull();

		//kalau telephoneCharges ada, tulis, kalau tidak, tulis null
		if (telephoneCharges != null) {
			midout = new DerOutputStream();
			telephoneCharges.encode (midout);
			dout.writeImplicit((byte)0xA6, midout);
		}
		else
			dout.putNull();

		//kalau businessCenterCharges ada, tulis, kalau tidak, tulis null
		if (businessCenterCharges != null) {
			midout = new DerOutputStream();
			businessCenterCharges.encode (midout);
			dout.writeImplicit((byte)0xA7, midout);
		}
		else
			dout.putNull();

		//kalau parkingCharges ada, tulis, kalau tidak, tulis null
		if (parkingCharges != null) {
			midout = new DerOutputStream();
			parkingCharges.encode (midout);
			dout.writeImplicit((byte)0xA8, midout);
		}
		else
			dout.putNull();

		//kalau movieCharges ada, tulis, kalau tidak, tulis null
		if (movieCharges != null) {
			midout = new DerOutputStream();
			movieCharges.encode (midout);
			dout.writeImplicit((byte)0xA9, midout);
		}
		else
			dout.putNull();

		//kalau healthClubCharges ada, tulis, kalau tidak, tulis null
		if (healthClubCharges != null) {
			midout = new DerOutputStream();
			healthClubCharges.encode (midout);
			dout.writeImplicit((byte)0xAA, midout);
		}
		else
			dout.putNull();

		//kalau giftShopPurchases ada, tulis, kalau tidak, tulis null
		if (giftShopPurchases != null) {
			midout = new DerOutputStream();
			giftShopPurchases.encode (midout);
			dout.writeImplicit((byte)0xAB, midout);
		}
		else
			dout.putNull();

		//kalau folioCashAdvances ada, tulis, kalau tidak, tulis null
		if (folioCashAdvances != null) {
			midout = new DerOutputStream();
			folioCashAdvances.encode (midout);
			dout.writeImplicit((byte)0xAC, midout);
		}
		else
			dout.putNull();

		//kalau otherCharges ada, tulis, kalau tidak, tulis null
		if (otherCharges != null) {
			midout = new DerOutputStream();
			otherCharges.encode (midout);
			dout.writeImplicit((byte)0xAD, midout);
		}
		else
			dout.putNull();

		//kalau totalTaxAmount ada, tulis, kalau tidak, tulis null
		if (totalTaxAmount != null) {
			midout = new DerOutputStream();
			totalTaxAmount.encode (midout);
			dout.writeImplicit((byte)0xAE, midout);
		}
		else
			dout.putNull();

		//kalau auditAdjustment ada, tulis, kalau tidak, tulis null
		if (auditAdjustment != null) {
			midout = new DerOutputStream();
			auditAdjustment.encode (midout);
			dout.writeImplicit((byte)0xAF, midout);
		}
		else
			dout.putNull();

		//tulis tag sequence
		DerOutputStream dout2 = new DerOutputStream();
		dout2.write(DerValue.tag_Sequence,dout);
		out.write(dout2.toByteArray());		//tulis semuanya ke dout
	}		

	/**
	 * Method for get DER Value 
	 *
	 * @param dout DerOutputStream for storing the result
	 */
	public void encode(DerOutputStream dout) throws IOException {
		derEncode(dout);
	}

	/**
	 * Method for get the roomCharges
	 */
	public CurrencyAmount getRoomCharges() {
		return roomCharges;
	}

	/**
	 * Method for get the roomTax
	 */
	public CurrencyAmount getRoomTax() {
		return roomTax;
	}

	/**
	 * Method for get the prepaidExpenses
	 */
	public CurrencyAmount getprepaidExpenses() {
		return prepaidExpenses;
	}

	/**
	 * Method for get the foodBeverageCharges
	 */
	public CurrencyAmount getFoodBeverageCharges() {
		return foodBeverageCharges;
	}

	/**
	 * Method for get the roomServiceCharges
	 */
	public CurrencyAmount getRoomServiceCharges() {
		return roomServiceCharges;
	}

	/**
	 * Method for get the miniBarCharges
	 */
	public CurrencyAmount getMiniBarCharges() {
		return miniBarCharges;
	}

	/**
	 * Method for get the laundryCharges
	 */
	public CurrencyAmount getLaundryCharges() {
		return laundryCharges;
	}

	/**
	 * Method for get the telephoneCharges
	 */
	public CurrencyAmount getTelephoneCharges() {
		return telephoneCharges;
	}

	/**
	 * Method for get the businessCenterCharges
	 */
	public CurrencyAmount getBusinessCenterCharges() {
		return businessCenterCharges;
	}

	/**
	 * Method for get the parkingCharges
	 */
	public CurrencyAmount getParkingCharges() {
		return parkingCharges;
	}

	/**
	 * Method for get the movieCharges
	 */
	public CurrencyAmount getMovieCharges() {
		return movieCharges;
	}

	/**
	 * Method for get the healthClubCharges
	 */
	public CurrencyAmount getHealthClubCharges() {
		return healthClubCharges;
	}

	/**
	 * Method for get the giftShopPurchases
	 */
	public CurrencyAmount getGiftShopPurchases() {
		return giftShopPurchases;
	}

	/**
	 * Method for get the folioCashAdvances
	 */
	public CurrencyAmount getFolioCashAdvances() {
		return folioCashAdvances;
	}

	/**
	 * Method for get the otherCharges
	 */
	public CurrencyAmount getOtherCharges() {
		return otherCharges;
	}

	/**
	 * Method for get the totalTaxAmount
	 */
	public CurrencyAmount getTotalTaxAmount() {
		return totalTaxAmount;
	}

	/**
	 * Method for get the auditAdjustment
	 */
	public CurrencyAmount getAuditAdjustment() {
		return auditAdjustment;
	}

	/**
	 * Method for get the string representation of this object
	 * @return string representation of HotelCharges object
	 */
	public String toString() {
		String s = "";

		s = s + "HotelCharges ::= roomCharges : " + roomCharges + "\n";

		if(roomTax != null)
			s = s + "HotelCharges ::= roomTax : " + roomTax + "\n";

		if(prepaidExpenses != null)
			s = s + "HotelCharges ::= prepaidExpenses : " + prepaidExpenses + "\n";

		if(foodBeverageCharges != null)
			s = s + "HotelCharges ::= foodBeverageCharges : " + foodBeverageCharges + "\n";

		if(roomServiceCharges != null)
			s = s + "HotelCharges ::= roomServiceCharges : " + roomServiceCharges + "\n";

		if(miniBarCharges != null)
			s = s + "HotelCharges ::= laundryCharges : " + laundryCharges + "\n";

		if(laundryCharges != null)
			s = s + "HotelCharges ::= miniBarCharges : " + miniBarCharges + "\n";

		if(telephoneCharges != null)
			s = s + "HotelCharges ::= telephoneCharges : " + telephoneCharges + "\n";

		if(businessCenterCharges != null)
			s = s + "HotelCharges ::= businessCenterCharges : " + businessCenterCharges + "\n";

		if(telephoneCharges != null)
			s = s + "HotelCharges ::= parkingCharges : " + parkingCharges + "\n";

		if(movieCharges != null)
			s = s + "HotelCharges ::= movieCharges : " + movieCharges + "\n";

		if(healthClubCharges != null)
			s = s + "HotelCharges ::= healthClubCharges : " + healthClubCharges + "\n";

		if(giftShopPurchases != null)
			s = s + "HotelCharges ::= giftShopPurchases : " + giftShopPurchases + "\n";

		if(folioCashAdvances != null)
			s = s + "HotelCharges ::= folioCashAdvances : " + folioCashAdvances + "\n";
	
		if(otherCharges != null)
			s = s + "HotelCharges ::= otherCharges : " + otherCharges + "\n";

		if(totalTaxAmount != null)
			s = s + "HotelCharges ::= totalTaxAmount : " + totalTaxAmount + "\n";

		if(auditAdjustment != null)
			s = s + "HotelCharges ::= AuditAdjustment : " + auditAdjustment + "\n";

		return s;
	}

	static void main(String[] args) {
		try 
		{
			CurrencyAmount roomCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount roomTax = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount prepaidExpenses = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount foodBeverageCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount roomServiceCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount miniBarCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount laundryCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount telephoneCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount businessCenterCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount parkingCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
 			CurrencyAmount movieCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount healthClubCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount giftShopPurchases = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount folioCashAdvances = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount otherCharges = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount totalTaxAmount = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));
			CurrencyAmount auditAdjustment = new CurrencyAmount(new BigInt(120),new BigInt(150),new BigInt(2));

			HotelCharges hotelCharges = new HotelCharges (roomCharges, roomTax,
				prepaidExpenses, foodBeverageCharges, roomServiceCharges, miniBarCharges,
				laundryCharges, telephoneCharges, businessCenterCharges, parkingCharges, movieCharges,
				healthClubCharges, giftShopPurchases, folioCashAdvances, otherCharges,
				totalTaxAmount, auditAdjustment);
			System.out.println(hotelCharges);

			DerOutputStream dout = new DerOutputStream();
			hotelCharges.encode(dout);
			HexDumpEncoder hde = new HexDumpEncoder();
			System.out.println(hde.encodeBuffer(dout.toByteArray()));

			System.out.println("*******reconstruct********");
			hotelCharges = new HotelCharges (new DerInputStream(dout.toByteArray()));
			System.out.println(hotelCharges);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}
