package digsec.set.payment.component.SaleDetail;

import java.io.OutputStream;
import java.io.IOException;
import sun.security.util.*;
import sun.misc.HexDumpEncoder;
import digsec.set.payment.component.CurrencyAmount;
import digsec.set.payment.component.Location;

/**
 *	<pre>
 *	1904 MsgExtensions ::= SETString (SIZE(30))
 *	</pre>
 */

public class MsgExtensions implements DerEncoder {
	
	private String msgExtensions;

	/**
	 * Constructor for MsgExtensions
	 */
	public MsgExtensions(String msgExtensions) throws Exception {
		if(msgExtensions.length()>30)
			throw new RuntimeException("Invalid input of MsgExtensions");

		this.msgExtensions = msgExtensions;
	}

	/**
	 * Constructor for MsgExtensions
	 * @param din DER representation of MsgExtensions
	 */
	public MsgExtensions(DerInputStream din) throws IOException {
		DerValue adv = din.getDerValue();

		// isi msgExtensions
		msgExtensions = adv.getPrintableString();
	}

	/**
	* Method for get DER Value 
	* @param out OutputStream for storing the result
	*/	
	public void derEncode(OutputStream out) throws IOException {
		DerOutputStream dout = new DerOutputStream();

		//tulis dist
		dout.putPrintableString(msgExtensions);
		out.write(dout.toByteArray());		//tulis semuanya ke out
	}		

	/**
	 * Method for get DER Value 
	 *
	 * @param dout DerOutputStream for storing the result
	 */
	public void encode(DerOutputStream dout) throws IOException {
		derEncode(dout);
	}

	/**
	 * Method for get the msgExtensions
	 *
	 * @return msgExtensions
	 */
	public String getMsgExtensions() {
		return msgExtensions;
	}

	/**
	 * Method for get the string representation of this object
	 *
	 * @return string representation of MsgExtensions object
	 */
	public String toString() {
		String s = "MsgExtensions ::= " + msgExtensions + "\n";
		return s;
	}

	static void main(String[] args) {
		try 
		{
			String data = "TRANSACTION SUCCESSFUL";
			MsgExtensions msgExtensions = new MsgExtensions (data);
			System.out.println(msgExtensions);

			DerOutputStream dout = new DerOutputStream();
			msgExtensions.encode(dout);
			HexDumpEncoder hde = new HexDumpEncoder();
			System.out.println(hde.encodeBuffer(dout.toByteArray()));

			System.out.println("*******reconstruct********");
			msgExtensions = new MsgExtensions (new DerInputStream(dout.toByteArray()));
			System.out.println(msgExtensions);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}

