package digsec.set.payment.component.SaleDetail;

import java.io.OutputStream;
import java.io.IOException;
import sun.security.util.*;
import sun.misc.HexDumpEncoder;
import digsec.set.payment.component.CurrencyAmount;
import digsec.set.payment.component.Location;

/**
 *	<pre>
 *	322 Phone ::= SETString { ub-phone=20 }
 *	</pre>
 */

public class Phone implements DerEncoder {
	
	private String phone;

	/**
	 * Constructor for Phone
	 */
	public Phone(String phone) throws Exception {
		if(phone.length()>20)
			throw new RuntimeException("Invalid input of Phone");

		this.phone = phone;
	}

	/**
	 * Constructor for Phone
	 * @param din DER representation of Phone
	 */
	public Phone(DerInputStream din) throws IOException {
		DerValue adv = din.getDerValue();

		// isi phone
		phone = adv.getPrintableString();
	}

	/**
	* Method for get DER Value 
	* @param out OutputStream for storing the result
	*/	
	public void derEncode(OutputStream out) throws IOException {
		DerOutputStream dout = new DerOutputStream();

		//tulis dist
		dout.putPrintableString(phone);
		out.write(dout.toByteArray());		//tulis semuanya ke out
	}		

	/**
	 * Method for get DER Value 
	 *
	 * @param dout DerOutputStream for storing the result
	 */
	public void encode(DerOutputStream dout) throws IOException {
		derEncode(dout);
	}

	/**
	 * Method for get the phone
	 *
	 * @return phone
	 */
	public String getPhone() {
		return phone;
	}

	/**
	 * Method for get the string representation of this object
	 *
	 * @return string representation of Phone object
	 */
	public String toString() {
		String s = "Phone ::= " + phone + "\n";
		return s;
	}

	static void main(String[] args) {
		try 
		{
			String data = "021-7357715";
			Phone phone = new Phone (data);
			System.out.println(phone);

			DerOutputStream dout = new DerOutputStream();
			phone.encode(dout);
			HexDumpEncoder hde = new HexDumpEncoder();
			System.out.println(hde.encodeBuffer(dout.toByteArray()));

			System.out.println("*******reconstruct********");
			phone = new Phone (new DerInputStream(dout.toByteArray()));
			System.out.println(phone);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}

