package digsec.set.payment.component.SaleDetail;

import java.io.OutputStream;
import java.io.IOException;
import sun.security.util.*;
import sun.misc.HexDumpEncoder;
import digsec.set.payment.component.CurrencyAmount;
import digsec.set.payment.component.Location;

/**
 *	<pre>
 *	3331 Restrictions ::= ENUMERATED {
 *	3332    unspecifiedRestriction  (0)
 *	3333 }
 *	</pre>
 */

public class Restrictions implements DerEncoder {
	
	public static BigInt unspecifiedRestriction = new BigInt(0);
	private BigInt value;

	/**
	 * Constructor for Restrictions
	 */
	public Restrictions(BigInt value) throws Exception {
		if(value.toInt()!=0)
			throw new RuntimeException("Invalid input of Restrictions");

		this.value = value;
	}

	/**
	 * Constructor for Restrictions
	 * @param din DER representation of Restrictions
	 */
	public Restrictions(DerInputStream din) throws IOException {
		this.value = din.getEnumerated();
	}

	/**
	* Method for get DER Value 
	*
	* @param out OutputStream for storing the result
	*/	
	public void derEncode(OutputStream out) throws IOException {
		DerOutputStream dout = new DerOutputStream();

		dout.putEnumerated (value);

		//tulis tag sequence
		out.write(dout.toByteArray());		//tulis semuanya ke out
	}		

	/**
	 * Method for get DER Value 
	 *
	 * @param dout DerOutputStream for storing the result
	 */
	public void encode(DerOutputStream dout) throws IOException {
		derEncode(dout);
	}

	/**
	 * Method for get the value
	 *
	 * @return value the value
	 */
	public BigInt getValue() {
		return value;
	}

	/**
	 * Method for get the string representation of this object
	 *
	 * @return string representation of Restrictions object
	 */
	public String toString() {
		String s = "";

		s = s + "Restrictions ::= unspecifiedRestriction \n";

		return s;
	}

	static void main(String[] args) {
		try 
		{
			BigInt value = new BigInt(0);
			Restrictions restrictions = new Restrictions (value);
			System.out.println(restrictions);

			DerOutputStream dout = new DerOutputStream();
			restrictions.encode(dout);
			HexDumpEncoder hde = new HexDumpEncoder();
			System.out.println(hde.encodeBuffer(dout.toByteArray()));

			System.out.println("*******reconstruct********");
			restrictions = new Restrictions (new DerInputStream(dout.toByteArray()));
			System.out.println(restrictions);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}

