package digsec.set.payment.message.AuthReqRes;

import sun.security.util.*;
import java.io.*;


/**
 *	<pre>
 *	1142 AuthCode ::= ENUMERATED {
 *	1143    approved                ( 0),
 *	1144    unspecifiedFailure      ( 1),
 *	1145    declined                ( 2),
 *	1146    noReply                 ( 3),
 *	1147    callIssuer              ( 4),
 *	1148    amountError             ( 5),
 *	1149    expiredCard             ( 6),
 *	1150    invalidTransaction      ( 7),
 *	1151    systemError             ( 8),
 *	1152    piPreviouslyUsed        ( 9),
 *	1153    recurringTooSoon        (10),
 *	1154    recurringExpired        (11),
 *	1155    piAuthMismatch          (12),
 *	1156    installRecurMismatch    (13),
 *	1157    captureNotSupported     (14),
 *	1158    signatureRequired       (15),
 *	1159    cardMerchBrandMismatch  (16)
 *	1160 }
 *	</pre>
 */

public class AuthCode implements DerEncoder {
	
	public static BigInt approved = new BigInt(0);
	public static BigInt unspecifiedFailure = new BigInt(1);
	public static BigInt declined = new BigInt(2);
	public static BigInt noReply = new BigInt(3);
	public static BigInt callIssuer = new BigInt(4);
	public static BigInt amountError = new BigInt(5);
	public static BigInt expiredCard = new BigInt(6);
	public static BigInt invalidTransaction = new BigInt(7);
	public static BigInt systemError = new BigInt(8);
	public static BigInt piPreviouslyUsed = new BigInt(9);
	public static BigInt recurringToSoon = new BigInt(10);
	public static BigInt recurringExpired = new BigInt(11);
	public static BigInt piAuthMismatch  = new BigInt(12);	
	public static BigInt installRecurMismatch = new BigInt(13);
	public static BigInt captureNotSupported = new BigInt(14);
	public static BigInt signatureRequired = new BigInt(15);
	public static BigInt cardMerchBrandMismatch = new BigInt(16);

	public BigInt code;

	public AuthCode(BigInt code) {
		this.code = code;
	}

	public AuthCode(DerInputStream din) throws Exception {
		code = din.getInteger();
	}

	public void derEncode(OutputStream out) throws IOException {
		DerOutputStream dout = new DerOutputStream();
		dout.putInteger(code);
		out.write(dout.toByteArray());
	}

	public void encode(DerOutputStream dout) throws IOException {
		derEncode(dout);
	}

	public String toString() {
		String s = "<AuthCode>\n";
		s += "code: " + code + "\n";
		return s;
	}

}