package digsec.set.payment.message.AuthReqRes;

import sun.security.util.*;
import java.io.*;
import digsec.set.payment.component.CurrencyAmount;

/**
 *	<pre>
 *	1734 BrandBatchDetails ::= SEQUENCE {
 *	1735    brandID      BrandID,
 *	1736    batchTotals  BatchTotals
 *	1737 }
 *
 *	232 BrandID ::= SETString { ub-BrandID }
 *	</pre>
 */

public class BrandBatchDetails implements DerEncoder {

	//fields
	public String 		BrandID;
	public BatchTotals	batchTotals;

	//constructor
	public BrandBatchDetails(String BrandID, BatchTotals batchTotals) throws Exception {
		this.BrandID = BrandID;
		this.batchTotals = batchTotals;
	}

	public BrandBatchDetails(DerInputStream din) throws Exception {
		din = din.getDerValue().toDerInputStream();
		BrandID = din.getDerValue().getPrintableString();
		batchTotals = new BatchTotals(din);
	}

	public void derEncode(OutputStream out) throws IOException {
		DerOutputStream dout = new DerOutputStream();
		dout.putPrintableString(BrandID);
		batchTotals.encode(dout);
		DerOutputStream dout2 = new DerOutputStream();
		dout2.write((byte)48,dout);
		out.write(dout2.toByteArray());
	}

	public void encode(DerOutputStream dout) throws IOException {
		derEncode(dout);
	}

	public String toString() {
		String s = "<BrandBatchDetails>\n";
		s += "BrandID: " + BrandID + "\n";
		s += "batchTotals:\n" + batchTotals;
		return s;
	}

	public static void main (String[] args) {
		try {
			CurrencyAmount cur = new CurrencyAmount(new BigInt(120),new BigInt(150),    new BigInt(2));  
			BatchTotals bt = new BatchTotals(new BigInt(100000), cur, new BigInt(2000000), cur);

			BrandBatchDetails bbd = new BrandBatchDetails("Dhany's",bt);
			System.out.println(bbd);
			DerOutputStream dout = new DerOutputStream();
			bbd.encode(dout);
			bbd = new BrandBatchDetails(new DerInputStream(dout.toByteArray()));
			System.out.println(bbd);

		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}
}