package digsec.set.payment.message.AuthReqRes;

import java.io.*;
import sun.security.util.*;
import java.util.*;


/**
 *	<pre>
 *	1706 ClosedWhen ::= SEQUENCE {
 *	1707    closeStatus    CloseStatus,
 *	1708    closeDateTime  Date
 *	1709 }
 *	1710
 *	1711 CloseStatus ::= ENUMERATED {
 *	1712    closedbyMerchant  (0),
 *	1713    closedbyAcquirer  (1)
 *	1714 }
 *	</pre>
 */

public class ClosedWhen implements DerEncoder {

	//fields
	public BigInt 	closeStatus;
	public Date		closeDateTime;

	//constant
	public static BigInt closedbyMerchant = new BigInt(0);
	public static BigInt closedbyAcquirer = new BigInt(1);

	//constructor
	public ClosedWhen (BigInt closeStatus, Date closeDateTime) throws Exception {
		this.closeStatus = closeStatus;
		this.closeDateTime = closeDateTime;
	}

	public ClosedWhen (DerInputStream din) throws Exception {
		din = din.getDerValue().toDerInputStream();
		closeStatus = new BigInt(din.getEnumerated().toInt());
		closeDateTime = din.getGeneralizedTime();
	}

	public void derEncode(OutputStream out) throws IOException {
		DerOutputStream dout = new DerOutputStream();
		dout.putEnumerated(closeStatus);
		dout.putGeneralizedTime(closeDateTime);
		DerOutputStream dout2 = new DerOutputStream();
		dout2.write((byte)48,dout);
		out.write(dout2.toByteArray());
	}

	public void encode(DerOutputStream dout) throws IOException {
		derEncode(dout);
	}

	public String toString() {
		String s = "<ClosedWhen>\n";
		s += "closeStatus: " + closeStatus + "\n";
		s += "closeDateTime: " + closeDateTime + "\n";
		return s;
	}

	public static void main (String[] args) {
		try {

			ClosedWhen cw = new ClosedWhen(ClosedWhen.closedbyMerchant,
							     new Date());
			System.out.println(cw);
			DerOutputStream dout = new DerOutputStream();
			cw.encode(dout);
			cw = new ClosedWhen(new DerInputStream(dout.toByteArray()));
			System.out.println(cw);
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}
}

	