package digsec.set.payment.wrapper;

import java.io.*;
import sun.security.util.*;
import java.security.*;
import java.security.cert.*;
import digsec.set.core.pkcs.*;
import digsec.set.core.encapsulation.*;
import digsec.set.core.crypto.*;
import digsec.set.payment.component.*;
import java.util.*;
import digsec.set.payment.message.AuthReqRes.*;

/**
 *	<pre> 	
 *
 * 	75 Message ::= CHOICE {
 * 	76
 * 	77    purchaseInitRequest          [ 0] EXPLICIT PInitReq,
 * 	78    purchaseInitResponse         [ 1] EXPLICIT PInitRes,
 *	79
 *	80    purchaseRequest              [ 2] EXPLICIT PReq,
 * 	81    purchaseResponse             [ 3] EXPLICIT PRes,
 * 	82
 * 	83    inquiryRequest               [ 4] EXPLICIT InqReq,
 * 	84    inquiryResponse              [ 5] EXPLICIT InqRes,
 * 	85
 * 	86    authorizationRequest         [ 6] EXPLICIT AuthReq,
 * 	87    authorizationResponse        [ 7] EXPLICIT AuthRes,
 * 	88
 * 	89    authReversalRequest          [ 8] EXPLICIT AuthRevReq,
 * 	90    authReversalResponse         [ 9] EXPLICIT AuthRevRes,
 * 	91
 * 	92    captureRequest               [10] EXPLICIT CapReq,
 * 	93    captureResponse              [11] EXPLICIT CapRes,
 * 	94
 * 	95    captureReversalRequest       [12] EXPLICIT CapRevReq,
 * 	96    captureReversalResponse      [13] EXPLICIT CapRevRes,
 * 	97
 * 	98    creditRequest                [14] EXPLICIT CredReq,
 * 	99    creditResponse               [15] EXPLICIT CredRes,
 *	100
 *	101    creditReversalRequest        [16] EXPLICIT CredRevReq,
 *	102    creditReversalResponse       [17] EXPLICIT CredRevRes,
 *	103
 *	104    pCertificateRequest          [18] EXPLICIT PCertReq,
 *	105    pCertificateResponse         [19] EXPLICIT PCertRes,
 *	106
 *	107    batchAdministrationRequest   [20] EXPLICIT BatchAdminReq,
 *	108    batchAdministrationResponse  [21] EXPLICIT BatchAdminRes,
 *	109
 *	110    cardholderCInitRequest       [22] EXPLICIT CardCInitReq,
 *	111    cardholderCInitResponse      [23] EXPLICIT CardCInitRes,
 *	112
 *	113    meAqCInitRequest             [24] EXPLICIT Me-AqCInitReq,
 *	114    meAqCInitResponse            [25] EXPLICIT Me-AqCInitRes,
 *	115
 *	116    registrationFormRequest      [26] EXPLICIT RegFormReq,
 *	117    registrationFormResponse     [27] EXPLICIT RegFormRes,
 *	118
 *	119    certificateRequest           [28] EXPLICIT CertReq,
 *	120    certificateResponse          [29] EXPLICIT CertRes,
 *	121
 *	122    certificateInquiryRequest    [30] EXPLICIT CertInqReq,
 *	123    certificateInquiryResponse   [31] EXPLICIT CertInqRes,
 *	124
 *	125    error                       [999] EXPLICIT Error
 *	126 }
 */

public class Message implements DerEncoder {

	public static byte tag_PInitReq = (byte) 0xA0;  
	public static byte tag_PInitRes = (byte) 0xA1;
   	public static byte tag_PReq = (byte) 0xA2;
	public static byte tag_PRes = (byte) 0xA3;
	public static byte tag_InqReq = (byte) 0xA4; 
    	public static byte tag_InqRes = (byte) 0xA5;
	public static byte tag_AuthReq = (byte) 0xA6;
     	public static byte tag_AuthRes = (byte) 0xA7; 
 	public static byte tag_AuthRevReq = (byte) 0xA8;
	public static byte tag_AuthRevRes = (byte) 0xA9;
      public static byte tag_CapReq = (byte) 0xAA; 
 	public static byte tag_CapRes = (byte) 0xAB;
     	public static byte tag_CapRevReq = (byte) 0xAC;
    	public static byte tag_CapRevRes = (byte) 0xAD;
  	public static byte tag_CredReq = (byte) 0xAE;
  	public static byte tag_CredRes = (byte) 0xAF;
	public static byte tag_CredRevReq = (byte) 0xB0;
 	public static byte tag_CredRevRes = (byte) 0xB1;
	public static byte tag_PCertReq = (byte) 0xB2;
	public static byte tag_PCertRes = (byte) 0xB3;
	public static byte tag_BatchAdminReq = (byte) 0xB4;
	public static byte tag_BatchAdminRes = (byte) 0xB5;
	public static byte tag_CardCInitReq = (byte) 0xB6;
	public static byte tag_CardCInitRes = (byte) 0xB7;
	public static byte tag_Me_AqCInitReq = (byte) 0xB8;
	public static byte tag_Me_AqCInitRes = (byte) 0xB9;
 	public static byte tag_RegFormReq = (byte) 0xBA;
 	public static byte tag_RegFormRes = (byte) 0xBB;
  	public static byte tag_CertReq = (byte) 0xBC;
 	public static byte tag_CertRes = (byte) 0xBD;
  	public static byte tag_CertInqReq = (byte) 0xBE;
 	public static byte tag_CertInqRes = (byte) 0xBF;
  	public static byte tag_Error = (byte) 999;

	public byte tag;

	public Message() {}

	public Message(PrivateKey priv, DerInputStream din) throws Exception {
		tag = (byte) din.peekByte();
	}
	
	public void derEncode(OutputStream out) throws IOException { }

	public void encode(DerOutputStream dout) throws IOException { }

	public static void main(String[] args) {
		try {
			byte[] RRPID = {8,1,2,3,1,7,8,1,2,3,1,7,8,1,2,3,1,7,2,3};
			MerTermIDs mti = new MerTermIDs("Arif","PCSC",
								  new BigInt(5),
								  new BigInt(6),
								  new BigInt(7));

			RRTags rr = new RRTags(RRPID,mti);

			//*******bikin transIDs*********
			byte[] lid_C = {8,1,2,3,1,7};
			byte[] lid_M = {2,1,0,3,1,7};
			Calendar calendar = Calendar.getInstance();
			calendar.set(1999,1,14);
			Date pReqDate = calendar.getTime();
			SecureRandom sr = new SecureRandom();	
			byte[] XID = new byte[20];
			sr.nextBytes(XID);

			TransIDs id = new TransIDs(lid_C,lid_M, XID, pReqDate, null, "English");

			AuthTags au = new AuthTags(rr,id,new BigInt(812));

			AuthCode ac = new AuthCode(AuthCode.approved);
			CurrencyAmount cur = new CurrencyAmount(new BigInt(120),new BigInt(150),    new BigInt(2));  
			AuthValCodes avc = new AuthValCodes("dhany", AuthValCodes.AuthCharInd_directMarketing,
									"arif", AuthValCodes.MarketSpecDataID_hotel);
			
			ResponseData rd = new ResponseData(avc,new BigInt(8), new BigInt(1),
								     new BigInt(2), "accepted");

			BatchTotals bt = new BatchTotals(new BigInt(100000), cur, new BigInt(2000000), cur);

			BrandBatchDetails bbd = new BrandBatchDetails("Dhany's",bt);
			BrandBatchDetails[] abbd = new BrandBatchDetails[3];
			abbd[0] = bbd;
			abbd[1] = bbd;
			abbd[2] = bbd;
			BrandBatchDetailsSeq seq = new BrandBatchDetailsSeq(abbd);
		
			BatchDetails bd = new BatchDetails(bt,seq);

			ClosedWhen cw = new ClosedWhen(ClosedWhen.closedbyMerchant,
							     new Date());

			BatchStatus bs = new BatchStatus(new Date(),cw, bd);

			AuthHeader ah = new AuthHeader(cur,ac,rd,bs);

			CapResPayload crp = new CapResPayload(new BigInt(0),cur,new BigInt(812), new BigInt(317));
		
			AuthResPayload arp = new AuthResPayload(ah,crp);

			AuthResData ard = new AuthResData(au,arp);

			//*************************************************
			//get payment-gateway's certificate
			InputStream inStream = new FileInputStream("d:\\digsec\\progie\\arif\\source\\digsec\\set\\application\\keystore\\pg.cert");
 			CertificateFactory cf = CertificateFactory.getInstance("X.509");
  			X509Certificate p_cert = (X509Certificate)cf.generateCertificate(inStream);
 			inStream.close();
			
			//get payment-gateway's private key
			inStream = new FileInputStream("d:\\digsec\\progie\\arif\\source\\digsec\\set\\application\\keystore\\pg.jks");
			java.security.KeyStore ks = java.security.KeyStore.getInstance("JKS", "SUN");
			ks.load(inStream,"PaymentGateway".toCharArray());
			PrivateKey p_priv = (PrivateKey) ks.getKey("PG", "PaymentGateway".toCharArray());

			byte[] authAmt = {8,1,2,3,1,7,8,1,2,3,1,7,8,1,2,3,1,7,2,3};
			//CurrencyAmount cur = new CurrencyAmount(new BigInt(120),new BigInt(150),    new BigInt(2));  

			CapTokenData ctd = new CapTokenData(authAmt,cur);

			byte[] ab = {0,1,2,3,4,5,6,7,8,9,0,1,2,3,4,5,6,7,8,9};
			PANToken pToken = new PANToken("1294", "199908", ab);

			CapToken ct = new CapToken(p_cert,p_priv,p_cert,ctd,pToken);

			//byte[] lid_C = {8,1,2,3,1,7};
			//TransIDs id = new TransIDs(lid_C,lid_C,"Priharsanta Inc.", "Javanese");
			
			Calendar cal = Calendar.getInstance();
			cal.set(1999,11,8);
			Recurring rec = new Recurring(new BigInt(28),
								cal.getTime());
			InstallRecurData install = new InstallRecurData(rec);

			AuthTokenData auth = new AuthTokenData(id,cur,"dodol812",install,
									   new BigInt(1), new Date(), 
									   null);
					
			AuthToken authToken = new AuthToken(p_priv,p_cert,p_cert,auth,pToken);

			AuthResBaggage arb = new AuthResBaggage(ct,authToken);
			
			//*******************************************

			AuthRes ar = new AuthRes(p_cert,p_priv,p_cert,ard,arb,pToken);
			Message msg = ar;
			System.out.println(msg);

			DerOutputStream dout = new DerOutputStream();
			msg.encode(dout);

			msg = new AuthRes(p_priv,new DerInputStream(dout.toByteArray()));
			System.out.println(msg);			

		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}
}