// Decompiled by Jad v1.5.6f. Copyright 1997-99 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/SiliconValley/Bridge/8617/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   KeyTool.java

//package sun.security.tools;
import sun.security.tools.*;
import java.security.*;
import javax.crypto.*;
import javax.crypto.spec.*;
import au.net.aba.crypto.provider.*;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FilterOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.io.PushbackInputStream;
import java.math.BigInteger;
import java.security.Certificate;
import java.security.Identity;
import java.security.Key;
import java.security.KeyStore;
import java.security.MessageDigest;
import java.security.Principal;
import java.security.PrivateKey;
import java.security.Provider;
import java.security.Signature;
import java.security.Signer;
import java.security.UnrecoverableKeyException;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;
import java.util.Arrays;
import java.util.Collection;
import java.util.Date;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import sun.misc.BASE64Encoder;
import sun.misc.CharacterEncoder;
import sun.security.pkcs.PKCS10;
import sun.security.provider.IdentityDatabase;
import sun.security.provider.SystemIdentity;
import sun.security.provider.SystemSigner;
import sun.security.provider.X509Factory;
import sun.security.util.DerOutputStream;
import sun.security.x509.AlgorithmId;
import sun.security.x509.CertAndKeyGen;
import sun.security.x509.CertificateAlgorithmId;
import sun.security.x509.CertificateIssuerName;
import sun.security.x509.CertificateSerialNumber;
import sun.security.x509.CertificateSubjectName;
import sun.security.x509.CertificateValidity;
import sun.security.x509.X500Name;
import sun.security.x509.X500Signer;
import sun.security.x509.X509CertImpl;
import sun.security.x509.X509CertInfo;

public final class KeyTool
{

    private KeyTool()
    {
        debug = false;
        command = null;
        sigAlgName = null;
        keyAlgName = "DSA";
        verbose = false;
        keysize = 1024;
        rfc = false;
        validity = 90;
        alias = null;
        dname = null;
        keyAlias = "mykey";
        dest = null;
        filename = null;
        storetype = null;
        storePass = null;
        storePassNew = null;
        keyPass = null;
        keyPassNew = null;
        oldPass = null;
        newPass = null;
        ksfname = null;
        ksfile = null;
        ksStream = null;
        inStream = null;
        keyStore = null;
        kssave = false;
        noprompt = false;
        trustcacerts = false;
        cf = null;
    }

    private boolean addTrustedCert(String s, InputStream inputstream)
        throws Exception
    {
        if(s == null)
            throw new Exception("Must specify alias");
        if(keyStore.containsAlias(s))
            throw new Exception("Certificate not imported, alias <" + s + "> already exists");
        X509Certificate x509certificate = null;
        try
        {
            x509certificate = (X509Certificate)cf.generateCertificate(inputstream);
        }
        catch(ClassCastException _ex)
        {
            throw new Exception("Input not an X.509 certificate");
        }
        catch(CertificateException _ex)
        {
            throw new Exception("Input not an X.509 certificate");
        }
        boolean flag = false;
        if(isSelfSigned(x509certificate))
        {
            x509certificate.verify(x509certificate.getPublicKey());
            flag = true;
        }
        if(noprompt)
        {
            keyStore.setCertificateEntry(s, x509certificate);
            return true;
        }
        String s1 = null;
        String s3 = keyStore.getCertificateAlias(x509certificate);
        if(s3 != null)
        {
            System.err.println("Certificate already exists in keystore under alias <" + s3 + ">");
            s1 = getYesNoReply("Do you still want to add it? [no]:  ");
        }
        else
        if(flag)
        {
            if(trustcacerts)
            {
                KeyStore keystore = getCacertsKeyStore();
                if(keystore != null && (s3 = keystore.getCertificateAlias(x509certificate)) != null)
                {
                    System.err.println("Certificate already exists in system-wide CA keystore under alias <" + s3 + ">");
                    s1 = getYesNoReply("Do you still want to add it to your own keystore? [no]:  ");
                }
            }
            if(s3 == null)
            {
                printX509Cert(x509certificate, System.out);
                s1 = getYesNoReply("Trust this certificate? [no]:  ");
            }
        }
        if(s1 != null)
            if(s1.equalsIgnoreCase("YES"))
            {
                keyStore.setCertificateEntry(s, x509certificate);
                return true;
            }
            else
            {
                return false;
            }
        try
        {
            java.security.cert.Certificate acertificate[] = establishCertChain(null, x509certificate);
            if(acertificate != null)
            {
                keyStore.setCertificateEntry(s, x509certificate);
                return true;
            }
        }
        catch(Exception _ex)
        {
            printX509Cert(x509certificate, System.out);
            String s2 = getYesNoReply("Trust this certificate? [no]:  ");
            if(s2.equalsIgnoreCase("YES"))
            {
                keyStore.setCertificateEntry(s, x509certificate);
                return true;
            }
            else
            {
                return false;
            }
        }
        return false;
    }

    private boolean buildChain(X509Certificate x509certificate, Vector vector, Hashtable hashtable)
    {
        Principal principal = x509certificate.getSubjectDN();
        Principal principal1 = x509certificate.getIssuerDN();
        if(principal.equals(principal1))
        {
            vector.addElement(x509certificate);
            return true;
        }
        Vector vector1 = (Vector)hashtable.get(principal1);
        if(vector1 == null)
            return false;
        Enumeration enumeration = vector1.elements();
        while(enumeration.hasMoreElements()) 
        {
            X509Certificate x509certificate1 = (X509Certificate)enumeration.nextElement();
            java.security.PublicKey publickey = x509certificate1.getPublicKey();
            try
            {
                x509certificate.verify(publickey);
            }
            catch(Exception _ex)
            {
                continue;
            }
            if(buildChain(x509certificate1, vector, hashtable))
            {
                vector.addElement(x509certificate);
                return true;
            }
        }

        return false;
    }

    private void byte2hex(byte byte0, StringBuffer stringbuffer)
    {
        char ac[] = {
            '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 
            'A', 'B', 'C', 'D', 'E', 'F'
        };
        int i = (byte0 & 0xf0) >> 4;
        int j = byte0 & 0xf;
        stringbuffer.append(ac[i]);
        stringbuffer.append(ac[j]);
    }

    private void doCertReq(String s, String s1, PrintStream printstream)
        throws Exception
    {
        if(s == null)
            s = keyAlias;
        Object aobj[] = recoverPrivateKey(s, storePass, keyPass);
        PrivateKey privatekey = (PrivateKey)aobj[0];
        if(keyPass == null)
            keyPass = (char[])aobj[1];
        java.security.cert.Certificate certificate = keyStore.getCertificate(s);
        if(certificate == null)
            throw new Exception(s + " has no public key (certificate)");
        PKCS10 pkcs10 = new PKCS10(certificate.getPublicKey());
        if(s1 == null)
        {
            String s2 = privatekey.getAlgorithm();
            if(s2.equalsIgnoreCase("DSA") || s2.equalsIgnoreCase("DSS"))
                s1 = "SHA1WithDSA";
            else
            if(s2.equalsIgnoreCase("RSA"))
                s1 = "MD5WithRSA";
            else
                throw new Exception("Cannot derive signature algorithm");
        }
        Signature signature = Signature.getInstance(s1);
        signature.initSign(privatekey);
        X500Name x500name = (X500Name)((X509Certificate)certificate).getSubjectDN();
        X500Signer x500signer = new X500Signer(signature, x500name);
        pkcs10.encodeAndSign(x500signer);
        pkcs10.print(printstream);
    }

    private void doChangeKeyPasswd(String s)
        throws Exception
    {
        if(s == null)
            s = keyAlias;
        Object aobj[] = recoverPrivateKey(s, storePass, keyPass);
        PrivateKey privatekey = (PrivateKey)aobj[0];
        if(keyPass == null)
            keyPass = (char[])aobj[1];
        if(keyPassNew == null)
            keyPassNew = getNewPasswd("key password for <" + s + ">", keyPass);
        keyStore.setKeyEntry(s, privatekey, keyPassNew, keyStore.getCertificateChain(s));
    }

    private void doCloneKey(String s, String s1)
        throws Exception
    {
        if(s == null)
            s = keyAlias;
        if(keyStore.containsAlias(s1))
            throw new Exception("Destination alias <" + s1 + "> already exists");
        Object aobj[] = recoverPrivateKey(s, storePass, keyPass);
        PrivateKey privatekey = (PrivateKey)aobj[0];
        if(keyPass == null)
            keyPass = (char[])aobj[1];
        if(keyPassNew == null)
        {
            int i = 0;
            do
            {
                keyPassNew = getKeyPasswd(s1, s, keyPass);
                if(keyPassNew.length < 6)
                {
                    System.err.println("Password is too short - must be at least 6 characters");
                    keyPassNew = null;
                }
                i++;
            }
            while(keyPassNew == null && i < 3);
            if(keyPassNew == null)
                throw new Exception("Too many failures. Key entry not cloned");
        }
        keyStore.setKeyEntry(s1, privatekey, keyPassNew, keyStore.getCertificateChain(s));
    }

    void doCommands(PrintStream printstream)
        throws Exception
    {
        if(command.equals("list") && verbose && rfc)
        {
            System.err.println("Must not specify both -v and -rfc with 'list' command");
            usage();
        }
        if(command.equals("keyclone") && dest == null)
        {
            dest = getAlias("destination");
            if(dest.equals(""))
                throw new Exception("Must specify destination alias");
        }
        if(command.equals("delete") && alias == null)
        {
            alias = getAlias(null);
            if(alias.equals(""))
                throw new Exception("Must specify alias");
        }
        if(storePass != null && storePass.length < 6)
            throw new Exception("Keystore password must be at least 6 characters");
        if(keyPass != null && keyPass.length < 6)
            throw new Exception("Key password must be at least 6 characters");
        if(newPass != null && newPass.length < 6)
            throw new Exception("New password must be at least 6 characters");
        if(!command.equals("printcert"))
        {
            if(ksfname == null)
                ksfname = System.getProperty("user.home") + File.separator + ".keystore";
            try
            {
                ksfile = new File(ksfname);
                if(ksfile.exists() && ksfile.length() == 0L)
                    throw new Exception("Keystore file exists, but is empty: " + ksfname);
                ksStream = new FileInputStream(ksfile);
            }
            catch(FileNotFoundException _ex)
            {
                if(!command.equals("genkey") && !command.equals("identitydb") && !command.equals("import"))
                    throw new Exception("Keystore file does not exist: " + ksfname);
            }
        }
        if(storetype != null)
            keyStore = KeyStore.getInstance(storetype);
        else
            keyStore = KeyStore.getInstance(KeyStore.getDefaultType());
        keyStore.load(ksStream, storePass);
        if(ksStream != null)
            ksStream.close();
        if(storePass == null)
        {
            if(command.equals("certreq") || command.equals("delete") || command.equals("genkey") || command.equals("import") || command.equals("keyclone") || command.equals("selfcert") || command.equals("storepasswd") || command.equals("keypasswd") || command.equals("identitydb"))
            {
                int i = 0;
                do
                {
                    System.err.print("Enter keystore password:  ");
                    System.err.flush();
                    storePass = readPasswd(System.in);
                    if(ksStream == null && storePass.length < 6)
                    {
                        System.err.println("Keystore password is too short - must be at least 6 characters");
                        storePass = null;
                    }
                    i++;
                }
                while(storePass == null && i < 3);
                if(storePass == null)
                {
                    System.err.println("Too many failures - try later");
                    return;
                }
            }
            else
            if(!command.equals("printcert"))
            {
                System.err.print("Enter keystore password:  ");
                System.err.flush();
                storePass = readPasswd(System.in);
            }
            if(ksStream != null)
            {
                ksStream = new FileInputStream(ksfile);
                keyStore.load(ksStream, storePass);
                ksStream.close();
            }
        }
        if(command.equals("printcert") || command.equals("import") || command.equals("identitydb"))
            cf = CertificateFactory.getInstance("X509");
        if(command.equals("certreq"))
        {
            if(filename != null)
            {
                PrintStream printstream1 = new PrintStream(new FileOutputStream(filename));
                printstream = printstream1;
            }
            doCertReq(alias, sigAlgName, printstream);
            if(verbose && filename != null)
            {
                System.err.println("Certification request stored in file <" + filename + ">");
                System.err.println("Submit this to your CA");
            }
        }
        else
        if(command.equals("delete"))
        {
            doDeleteEntry(alias);
            kssave = true;
        }
        else
        if(command.equals("export"))
        {
            if(filename != null)
            {
                PrintStream printstream2 = new PrintStream(new FileOutputStream(filename));
                printstream = printstream2;
            }
            doExportCert(alias, printstream);
            if(filename != null)
                System.err.println("Certificate stored in file <" + filename + ">");
        }
        else
        if(command.equals("genkey"))
        {
            doGenKeyPair(alias, dname, keyAlgName, keysize, sigAlgName);
            kssave = true;
        }
        else
        if(command.equals("identitydb"))
        {
            Object obj = System.in;
            if(filename != null)
                obj = new FileInputStream(filename);
            doImportIdentityDatabase(((InputStream) (obj)));
        }
        else
        if(command.equals("import"))
        {
            Object obj1 = System.in;
            if(filename != null)
                obj1 = new FileInputStream(filename);
            String s = alias == null ? keyAlias : alias;
            if(keyStore.isKeyEntry(s))
            {
                kssave = installReply(s, ((InputStream) (obj1)));
                if(kssave)
                    System.err.println("Certificate reply was installed in keystore");
                else
                    System.err.println("Certificate reply was not installed in keystore");
            }
            else
            {
                kssave = addTrustedCert(s, ((InputStream) (obj1)));
                if(kssave)
                    System.err.println("Certificate was added to keystore");
                else
                    System.err.println("Certificate was not added to keystore");
            }
        }
        else
        if(command.equals("keyclone"))
        {
            keyPassNew = newPass;
            doCloneKey(alias, dest);
            kssave = true;
        }
        else
        if(command.equals("keypasswd"))
        {
            keyPassNew = newPass;
            doChangeKeyPasswd(alias);
            kssave = true;
        }
        else
        if(command.equals("list"))
        {
            if(alias != null)
                doPrintEntry(alias, printstream, true);
            else
                doPrintEntries(printstream);
        }
        else
        if(command.equals("printcert"))
        {
            Object obj2 = System.in;
            if(filename != null)
                obj2 = new FileInputStream(filename);
            doPrintCert(((InputStream) (obj2)), printstream);
        }
        else
        if(command.equals("selfcert"))
        {
            doSelfCert(alias, dname, sigAlgName);
            kssave = true;
        }
        else
        if(command.equals("storepasswd"))
        {
            storePassNew = newPass;
            if(storePassNew == null)
                storePassNew = getNewPasswd("keystore password", storePass);
            kssave = true;
        }
        if(kssave)
        {
            if(verbose)
                System.err.println("[Saving " + ksfname + "]");
            FileOutputStream fileoutputstream = new FileOutputStream(ksfname);
            keyStore.store(fileoutputstream, storePassNew == null ? storePass : storePassNew);
            fileoutputstream.close();
        }
    }

    private void doDeleteEntry(String s)
        throws Exception
    {
        if(!keyStore.containsAlias(s))
        {
            throw new Exception("Alias <" + s + "> does not exist");
        }
        else
        {
            keyStore.deleteEntry(s);
            return;
        }
    }

    private void doExportCert(String s, PrintStream printstream)
        throws Exception
    {
        if(storePass == null)
            printWarning();
        if(s == null)
            s = keyAlias;
        if(!keyStore.containsAlias(s))
            throw new Exception("Alias <" + s + "> does not exist");
        X509Certificate x509certificate = (X509Certificate)keyStore.getCertificate(s);
        if(x509certificate == null)
        {
            throw new Exception("Alias <" + s + "> has no certificate");
        }
        else
        {
            dumpCert(x509certificate, printstream);
            return;
        }
    }

    private void doGenKeyPair(String s, String s1, String s2, int i, String s3)
        throws Exception
    {
        if(s == null)
            s = keyAlias;
        if(keyStore.containsAlias(s))
            throw new Exception("Key pair not generated, alias <" + s + "> already exists");
        if(s3 == null)
            if(s2.equalsIgnoreCase("DSA"))
                s3 = "SHA1WithDSA";
            else
            if(s2.equalsIgnoreCase("RSA"))
                s3 = "MD5WithRSA";
            else
                throw new Exception("Cannot derive signature algorithm");
        CertAndKeyGen certandkeygen = new CertAndKeyGen(s2, s3);
        X500Name x500name;
        if(s1 == null)
            x500name = getX500Name();
        else
            x500name = new X500Name(s1);
        if(verbose)
        {
            System.err.println("Generating " + i + " bit " + s2 + " key pair and " + "self-signed certificate (" + s3 + ")");
            System.err.println("\tfor: " + x500name);
        }
        certandkeygen.generate(i);
        PrivateKey privatekey = certandkeygen.getPrivateKey();
        X509Certificate ax509certificate[] = new X509Certificate[1];
        ax509certificate[0] = certandkeygen.getSelfCertificate(x500name, validity * 24 * 60 * 60);
        if(keyPass == null)
        {
            int j;
            for(j = 0; j < 3 && keyPass == null; j++)
            {
                System.err.println("Enter key password for <" + s + ">");
                System.err.print("\t(RETURN if same as keystore password):  ");
                System.err.flush();
                keyPass = readPasswd(System.in);
                if(keyPass == null)
                    keyPass = storePass;
                else
                if(keyPass.length < 6)
                {
                    System.err.println("Key password is too short - must be at least 6 characters");
                    keyPass = null;
                }
            }

            if(j == 3)
                throw new Exception("Too many failures - key not added to keystore");
        }
        keyStore.setKeyEntry(s, privatekey, keyPass, ax509certificate);
    }

    private void doImportIdentityDatabase(InputStream inputstream)
        throws Exception
    {
        java.security.cert.Certificate acertificate[] = null;
        boolean flag = false;
        IdentityDatabase identitydatabase = IdentityDatabase.fromStream(inputstream);
        Enumeration enumeration = identitydatabase.identities();
        while(enumeration.hasMoreElements()) 
        {
            Identity identity = (Identity)enumeration.nextElement();
            X509Certificate x509certificate = null;
            if((!(identity instanceof SystemSigner) || !((SystemSigner)identity).isTrusted()) && (!(identity instanceof SystemIdentity) || !((SystemIdentity)identity).isTrusted()))
                continue;
            if(keyStore.containsAlias(identity.getName()))
            {
                System.err.println("Keystore entry for <" + identity.getName() + "> already exists");
                continue;
            }
            Certificate acertificate1[] = identity.certificates();
            if(acertificate1 == null || acertificate1.length <= 0)
                continue;
            DerOutputStream deroutputstream = new DerOutputStream();
            acertificate1[0].encode(deroutputstream);
            byte abyte0[] = deroutputstream.toByteArray();
            ByteArrayInputStream bytearrayinputstream = new ByteArrayInputStream(abyte0);
            x509certificate = (X509Certificate)cf.generateCertificate(bytearrayinputstream);
            bytearrayinputstream.close();
            if(isSelfSigned(x509certificate))
            {
                java.security.PublicKey publickey = x509certificate.getPublicKey();
                try
                {
                    x509certificate.verify(publickey);
                }
                catch(Exception _ex)
                {
                    continue;
                }
            }
            if(identity instanceof SystemSigner)
            {
                System.err.println("Creating keystore entry for <" + identity.getName() + "> ...");
                if(acertificate == null)
                    acertificate = new java.security.cert.Certificate[1];
                acertificate[0] = x509certificate;
                PrivateKey privatekey = ((SystemSigner)identity).getPrivateKey();
                keyStore.setKeyEntry(identity.getName(), privatekey, storePass, acertificate);
            }
            else
            {
                keyStore.setCertificateEntry(identity.getName(), x509certificate);
            }
            kssave = true;
        }

        if(!kssave)
            System.err.println("No entries from identity database added");
    }

    private void doPrintCert(InputStream inputstream, PrintStream printstream)
        throws Exception
    {
        Collection collection = null;
        try
        {
            collection = cf.generateCertificates(inputstream);
        }
        catch(CertificateException _ex)
        {
            throw new Exception("Failed to parse input");
        }
        if(collection.isEmpty())
            throw new Exception("Empty input");
        java.security.cert.Certificate acertificate[] = (java.security.cert.Certificate[])collection.toArray();
        for(int i = 0; i < acertificate.length; i++)
        {
            X509Certificate x509certificate = null;
            try
            {
                x509certificate = (X509Certificate)acertificate[i];
            }
            catch(ClassCastException _ex)
            {
                throw new Exception("Not X.509 certificate");
            }
            if(acertificate.length > 1)
                printstream.println("Certificate[" + (i + 1) + "]:");
            printX509Cert(x509certificate, printstream);
            if(i < acertificate.length - 1)
                printstream.println();
        }

    }

    private void doPrintEntries(PrintStream printstream)
        throws Exception
    {
        if(storePass == null)
            printWarning();
        else
            printstream.println();
        printstream.println("Keystore type: " + keyStore.getType());
        printstream.println("Keystore provider: " + keyStore.getProvider().getName());
        printstream.println();
        printstream.println("Your keystore contains " + keyStore.size() + " entr" + (keyStore.size() != 1 ? "ies:" : "y:"));
        printstream.println();
        for(Enumeration enumeration = keyStore.aliases(); enumeration.hasMoreElements();)
        {
            String s = (String)enumeration.nextElement();
            doPrintEntry(s, printstream, false);
            if(verbose || rfc)
            {
                printstream.println("\n");
                printstream.println("*******************************************");
                printstream.println("*******************************************\n\n");
            }
        }

    }

    private void doPrintEntry(String s, PrintStream printstream, boolean flag)
        throws Exception
    {
        if(storePass == null && flag)
            printWarning();
        if(!keyStore.containsAlias(s))
            throw new Exception("Alias <" + s + "> does not exist");
        if(verbose || rfc || debug)
        {
            printstream.println("Alias name: " + s);
            printstream.println("Creation date: " + keyStore.getCreationDate(s).toString());
        }
        else
        {
            printstream.print(s + ", " + keyStore.getCreationDate(s).toString() + ", ");
        }
        if(keyStore.isKeyEntry(s))
        {
            if(verbose || rfc || debug)
                printstream.println("Entry type: keyEntry");
            else
                printstream.println("keyEntry,");
            java.security.cert.Certificate acertificate[] = keyStore.getCertificateChain(s);
            if(acertificate != null)
                if(verbose || rfc || debug)
                {
                    printstream.println("Certificate chain length: " + acertificate.length);
                    for(int i = 0; i < acertificate.length; i++)
                    {
                        printstream.println("Certificate[" + (i + 1) + "]:");
                        if(verbose && (acertificate[i] instanceof X509Certificate))
                            printX509Cert((X509Certificate)acertificate[i], printstream);
                        else
                        if(debug)
                            printstream.println(acertificate[i].toString());
                        else
                            dumpCert(acertificate[i], printstream);
                    }

                }
                else
                {
                    printstream.println("Certificate fingerprint (MD5): " + getCertFingerPrint("MD5", acertificate[0]));
                }
        }
        else
        {
            java.security.cert.Certificate certificate = keyStore.getCertificate(s);
            if(verbose && (certificate instanceof X509Certificate))
            {
                printstream.println("Entry type: trustedCertEntry\n");
                printX509Cert((X509Certificate)certificate, printstream);
            }
            else
            if(rfc)
            {
                printstream.println("Entry type: trustedCertEntry\n");
                dumpCert(certificate, printstream);
            }
            else
            if(debug)
            {
                printstream.println(certificate.toString());
            }
            else
            {
                printstream.println("trustedCertEntry,");
                printstream.println("Certificate fingerprint (MD5): " + getCertFingerPrint("MD5", certificate));
            }
        }
    }

    private void doSelfCert(String s, String s1, String s2)
        throws Exception
    {
        if(s == null)
            s = keyAlias;
        Object aobj[] = recoverPrivateKey(s, storePass, keyPass);
        PrivateKey privatekey = (PrivateKey)aobj[0];
        if(keyPass == null)
            keyPass = (char[])aobj[1];
        if(s2 == null)
        {
            String s3 = privatekey.getAlgorithm();
            if(s3.equalsIgnoreCase("DSA") || s3.equalsIgnoreCase("DSS"))
                s2 = "SHA1WithDSA";
            else
            if(s3.equalsIgnoreCase("RSA"))
                s2 = "MD5WithRSA";
            else
                throw new Exception("Cannot derive signature algorithm");
        }
        java.security.cert.Certificate certificate = keyStore.getCertificate(s);
        if(certificate == null)
            throw new Exception(s + " has no public key");
        if(!(certificate instanceof X509Certificate))
            throw new Exception(s + " has no X.509 certificate");
        byte abyte0[] = certificate.getEncoded();
        X509CertImpl x509certimpl = new X509CertImpl(abyte0);
        X509CertInfo x509certinfo = (X509CertInfo)x509certimpl.get("x509.info");
        Date date = new Date();
        Date date1 = new Date();
        date1.setTime(date.getTime() + (long)(validity * 1000 * 24 * 60) * 60L);
        CertificateValidity certificatevalidity = new CertificateValidity(date, date1);
        x509certinfo.set("validity", certificatevalidity);
        x509certinfo.set("serialNumber", new CertificateSerialNumber((int)(date.getTime() / 1000L)));
        X500Name x500name;
        if(s1 == null)
        {
            x500name = (X500Name)x509certinfo.get("subject.dname");
        }
        else
        {
            x500name = new X500Name(s1);
            x509certinfo.set("subject.dname", x500name);
        }
        x509certinfo.set("issuer.dname", x500name);
        X509CertImpl x509certimpl1 = new X509CertImpl(x509certinfo);
        x509certimpl1.sign(privatekey, s2);
        AlgorithmId algorithmid = (AlgorithmId)x509certimpl1.get("x509.algorithm");
        x509certinfo.set("algorithmID.algorithm", algorithmid);
        x509certimpl1 = new X509CertImpl(x509certinfo);
        x509certimpl1.sign(privatekey, s2);
        keyStore.setKeyEntry(s, privatekey, keyPass == null ? storePass : keyPass, new java.security.cert.Certificate[] {
            x509certimpl1
        });
        if(verbose)
        {
            System.err.println("New certificate (self-signed):");
            System.err.print(x509certimpl1.toString());
            System.err.println();
        }
    }

    private void dumpCert(java.security.cert.Certificate certificate, PrintStream printstream)
        throws IOException, CertificateException
    {
        if(rfc)
        {
            BASE64Encoder base64encoder = new BASE64Encoder();
            printstream.println("-----BEGIN CERTIFICATE-----");
            base64encoder.encodeBuffer(certificate.getEncoded(), printstream);
            printstream.println("-----END CERTIFICATE-----");
        }
        else
        {
            printstream.write(certificate.getEncoded());
        }
    }

    private java.security.cert.Certificate[] establishCertChain(java.security.cert.Certificate certificate, java.security.cert.Certificate certificate1)
        throws Exception
    {
        if(certificate != null)
        {
            java.security.PublicKey publickey = certificate.getPublicKey();
            java.security.PublicKey publickey1 = certificate1.getPublicKey();
            if(!publickey.equals(publickey1))
            {
                String s = "Public keys in reply and keystore don't match";
                throw new Exception(s);
            }
            if(certificate1.equals(certificate))
            {
                String s1 = "Certificate reply and certificate in keystore are identical";
                throw new Exception(s1);
            }
        }
        Hashtable hashtable = null;
        if(keyStore.size() > 0)
        {
            hashtable = new Hashtable(11);
            keystorecerts2Hashtable(keyStore, hashtable);
        }
        if(trustcacerts)
        {
            KeyStore keystore = getCacertsKeyStore();
            if(keystore != null && keystore.size() > 0)
            {
                if(hashtable == null)
                    hashtable = new Hashtable(11);
                keystorecerts2Hashtable(keystore, hashtable);
            }
        }
        Vector vector = new Vector(2);
        if(buildChain((X509Certificate)certificate1, vector, hashtable))
        {
            java.security.cert.Certificate acertificate[] = new java.security.cert.Certificate[vector.size()];
            int i = 0;
            for(int j = vector.size() - 1; j >= 0; j--)
            {
                acertificate[i] = (java.security.cert.Certificate)vector.elementAt(j);
                i++;
            }

            return acertificate;
        }
        else
        {
            throw new Exception("Failed to establish chain from reply");
        }
    }

    private String getAlias(String s)
        throws Exception
    {
        if(s != null)
            System.err.print("Enter " + s + " alias name:  ");
        else
            System.err.print("Enter alias name:  ");
        return (new BufferedReader(new InputStreamReader(System.in))).readLine();
    }

    private KeyStore getCacertsKeyStore()
        throws Exception
    {
        String s = File.separator;
        File file = new File(System.getProperty("java.home") + s + "lib" + s + "security" + s + "cacerts");
        if(!file.exists())
        {
            return null;
        }
        else
        {
            FileInputStream fileinputstream = new FileInputStream(file);
            KeyStore keystore = KeyStore.getInstance("jks");
            keystore.load(fileinputstream, null);
            fileinputstream.close();
            return keystore;
        }
    }

    private String getCertFingerPrint(String s, java.security.cert.Certificate certificate)
        throws Exception
    {
        byte abyte0[] = certificate.getEncoded();
        MessageDigest messagedigest = MessageDigest.getInstance(s);
        byte abyte1[] = messagedigest.digest(abyte0);
        return toHexString(abyte1);
    }

    private char[] getKeyPasswd(String s, String s1, char ac[])
        throws Exception
    {
        int i = 0;
        char ac1[] = null;
        do
        {
            if(ac != null)
            {
                System.err.println("Enter key password for <" + s + ">");
                System.err.print("\t(RETURN if same as for <" + s1 + ">):  ");
            }
            else
            {
                System.err.print("Enter key password for <" + s + ">:  ");
            }
            System.err.flush();
            ac1 = readPasswd(System.in);
            if(ac1 == null)
                ac1 = ac;
            i++;
        }
        while(ac1 == null && i < 3);
        if(ac1 == null)
            throw new Exception("Too many failures - try later");
        else
            return ac1;
    }

    private char[] getNewPasswd(String s, char ac[])
        throws Exception
    {
        Object obj = null;
        char ac2[] = null;
        for(int i = 0; i < 3; i++)
        {
            System.err.print("New " + s + ":  ");
            char ac1[] = readPasswd(System.in);
            if(ac1.length < 6)
                System.err.println("Password is too short - must be at least 6 characters");
            else
            if(Arrays.equals(ac1, ac))
            {
                System.err.println("Passwords must differ");
            }
            else
            {
                System.err.print("Re-enter new " + s + ":  ");
                ac2 = readPasswd(System.in);
                if(!Arrays.equals(ac1, ac2))
                {
                    System.err.println("They don't match; try again");
                }
                else
                {
                    Arrays.fill(ac2, ' ');
                    return ac1;
                }
            }
            if(ac1 != null)
            {
                Arrays.fill(ac1, ' ');
                ac1 = null;
            }
            if(ac2 != null)
            {
                Arrays.fill(ac2, ' ');
                ac2 = null;
            }
        }

        throw new Exception("Too many failures - try later");
    }

    private X500Name getX500Name()
        throws IOException
    {
        BufferedReader bufferedreader = new BufferedReader(new InputStreamReader(System.in));
        String s = "Unknown";
        String s1 = "Unknown";
        String s2 = "Unknown";
        String s3 = "Unknown";
        String s4 = "Unknown";
        String s5 = "Unknown";
        String s6 = null;
        X500Name x500name;
        do
        {
            s = inputString(bufferedreader, "What is your first and last name?", s);
            s1 = inputString(bufferedreader, "What is the name of your organizational unit?", s1);
            s2 = inputString(bufferedreader, "What is the name of your organization?", s2);
            s3 = inputString(bufferedreader, "What is the name of your City or Locality?", s3);
            s4 = inputString(bufferedreader, "What is the name of your State or Province?", s4);
            s5 = inputString(bufferedreader, "What is the two-letter country code for this unit?", s5);
            x500name = new X500Name(s, s1, s2, s3, s4, s5);
            s6 = inputString(bufferedreader, "Is <" + x500name + "> correct?", "no");
        }
        while(!s6.equalsIgnoreCase("yes") && !s6.equalsIgnoreCase("y"));
        System.err.println();
        return x500name;
    }

    private String getYesNoReply(String s)
        throws IOException
    {
        String s1 = null;
        do
        {
            System.err.print(s);
            System.err.flush();
            s1 = (new BufferedReader(new InputStreamReader(System.in))).readLine();
            if(s1.equals("") || s1.equalsIgnoreCase("n") || s1.equalsIgnoreCase("no"))
                s1 = "NO";
            else
            if(s1.equalsIgnoreCase("y") || s1.equalsIgnoreCase("yes"))
            {
                s1 = "YES";
            }
            else
            {
                System.err.println("Wrong answer, try again");
                s1 = null;
            }
        }
        while(s1 == null);
        return s1;
    }

    private String inputString(BufferedReader bufferedreader, String s, String s1)
        throws IOException
    {
        System.err.println(s);
        System.err.print("  [" + s1 + "]:  ");
        System.err.flush();
        String s2 = bufferedreader.readLine();
        if(s2 == null || s2.equals(""))
            s2 = s1;
        return s2;
    }

    private boolean installReply(String s, InputStream inputstream)
        throws Exception
    {
        if(s == null)
            s = keyAlias;
        Object aobj[] = recoverPrivateKey(s, storePass, keyPass);
        PrivateKey privatekey = (PrivateKey)aobj[0];
        if(keyPass == null)
            keyPass = (char[])aobj[1];
        java.security.cert.Certificate certificate = keyStore.getCertificate(s);
        if(certificate == null)
            throw new Exception(s + " has no public key (certificate)");
        Collection collection = cf.generateCertificates(inputstream);
        if(collection.isEmpty())
            throw new Exception("Reply has no certificates");
        java.security.cert.Certificate acertificate[] = (java.security.cert.Certificate[])collection.toArray();
        java.security.cert.Certificate acertificate1[];
        if(acertificate.length == 1)
            acertificate1 = establishCertChain(certificate, acertificate[0]);
        else
            acertificate1 = validateReply(s, certificate, acertificate);
        if(acertificate1 != null)
        {
            keyStore.setKeyEntry(s, privatekey, keyPass == null ? storePass : keyPass, acertificate1);
            return true;
        }
        else
        {
            return false;
        }
    }

    private boolean isSelfSigned(X509Certificate x509certificate)
    {
        X500Name x500name = (X500Name)x509certificate.getSubjectDN();
        X500Name x500name1 = (X500Name)x509certificate.getIssuerDN();
        return x500name.equals(x500name1);
    }

    private boolean isTrusted(java.security.cert.Certificate certificate)
        throws Exception
    {
        if(keyStore.getCertificateAlias(certificate) != null)
            return true;
        KeyStore keystore;
        return trustcacerts && (keystore = getCacertsKeyStore()) != null && keystore.getCertificateAlias(certificate) != null;
    }

    private void keystorecerts2Hashtable(KeyStore keystore, Hashtable hashtable)
        throws Exception
    {
        for(Enumeration enumeration = keystore.aliases(); enumeration.hasMoreElements();)
        {
            String s = (String)enumeration.nextElement();
            java.security.cert.Certificate certificate = keystore.getCertificate(s);
            if(certificate != null)
            {
                Principal principal = ((X509Certificate)certificate).getSubjectDN();
                Vector vector = (Vector)hashtable.get(principal);
                if(vector == null)
                {
                    vector = new Vector();
                    vector.addElement(certificate);
                }
                else
                if(!vector.contains(certificate))
                    vector.addElement(certificate);
                hashtable.put(principal, vector);
            }
        }

    }

    public static void main(String args[])
    {
        KeyTool keytool = new KeyTool();
        keytool.run(args, System.out);
    }

    void parseArgs(String as[])
    {
        if(as.length == 0)
            usage();
        int i = 0;
        for(i = 0; i < as.length && as[i].startsWith("-"); i++)
        {
            String s = as[i];
            if(s.equalsIgnoreCase("-certreq"))
                command = "certreq";
            else
            if(s.equalsIgnoreCase("-delete"))
                command = "delete";
            else
            if(s.equalsIgnoreCase("-export"))
                command = "export";
            else
            if(s.equalsIgnoreCase("-genkey"))
            {
                command = "genkey";
            }
            else
            {
                if(s.equalsIgnoreCase("-help"))
                {
                    usage();
                    return;
                }
                if(s.equalsIgnoreCase("-identitydb"))
                    command = "identitydb";
                else
                if(s.equalsIgnoreCase("-import"))
                    command = "import";
                else
                if(s.equalsIgnoreCase("-keyclone"))
                    command = "keyclone";
                else
                if(s.equalsIgnoreCase("-keypasswd"))
                    command = "keypasswd";
                else
                if(s.equalsIgnoreCase("-list"))
                    command = "list";
                else
                if(s.equalsIgnoreCase("-printcert"))
                    command = "printcert";
                else
                if(s.equalsIgnoreCase("-selfcert"))
                    command = "selfcert";
                else
                if(s.equalsIgnoreCase("-storepasswd"))
                    command = "storepasswd";
                else
                if(s.equalsIgnoreCase("-keystore"))
                {
                    if(++i == as.length)
                        usage();
                    ksfname = as[i];
                }
                else
                if(s.equalsIgnoreCase("-storepass"))
                {
                    if(++i == as.length)
                        usage();
                    storePass = as[i].toCharArray();
                }
                else
                if(s.equalsIgnoreCase("-storetype"))
                {
                    if(++i == as.length)
                        usage();
                    storetype = as[i];
                }
                else
                if(s.equalsIgnoreCase("-keypass"))
                {
                    if(++i == as.length)
                        usage();
                    keyPass = as[i].toCharArray();
                }
                else
                if(s.equalsIgnoreCase("-new"))
                {
                    if(++i == as.length)
                        usage();
                    newPass = as[i].toCharArray();
                }
                else
                if(s.equalsIgnoreCase("-alias"))
                {
                    if(++i == as.length)
                        usage();
                    alias = as[i];
                }
                else
                if(s.equalsIgnoreCase("-dest"))
                {
                    if(++i == as.length)
                        usage();
                    dest = as[i];
                }
                else
                if(s.equalsIgnoreCase("-dname"))
                {
                    if(++i == as.length)
                        usage();
                    dname = as[i];
                }
                else
                if(s.equalsIgnoreCase("-keysize"))
                {
                    if(++i == as.length)
                        usage();
                    keysize = Integer.parseInt(as[i]);
                }
                else
                if(s.equalsIgnoreCase("-keyalg"))
                {
                    if(++i == as.length)
                        usage();
                    keyAlgName = as[i];
                }
                else
                if(s.equalsIgnoreCase("-sigalg"))
                {
                    if(++i == as.length)
                        usage();
                    sigAlgName = as[i];
                }
                else
                if(s.equalsIgnoreCase("-validity"))
                {
                    if(++i == as.length)
                        usage();
                    validity = Integer.parseInt(as[i]);
                }
                else
                if(s.equalsIgnoreCase("-file"))
                {
                    if(++i == as.length)
                        usage();
                    filename = as[i];
                }
                else
                if(s.equalsIgnoreCase("-v"))
                    verbose = true;
                else
                if(s.equalsIgnoreCase("-debug"))
                    debug = true;
                else
                if(s.equalsIgnoreCase("-rfc"))
                    rfc = true;
                else
                if(s.equalsIgnoreCase("-noprompt"))
                    noprompt = true;
                else
                if(s.equalsIgnoreCase("-trustcacerts"))
                {
                    trustcacerts = true;
                }
                else
                {
                    System.err.println("Illegal option:  " + s);
                    usage();
                }
            }
        }

        if(i < as.length || command == null)
            usage();
    }

    private void printWarning()
    {
        System.err.println();
        System.err.print("*****************  ");
        System.err.print("WARNING WARNING WARNING  ");
        System.err.println("*****************");
        System.err.print("* The integrity of the information stored in ");
        System.err.println("your keystore  *");
        System.err.print("* has NOT been verified!  ");
        System.err.println("In order to verify its integrity, *");
        System.err.print("* you must provide your keystore password.");
        System.err.println("                  *");
        System.err.print("*****************  ");
        System.err.print("WARNING WARNING WARNING  ");
        System.err.println("*****************");
        System.err.println();
    }

    private void printX509Cert(X509Certificate x509certificate, PrintStream printstream)
        throws Exception
    {
        printstream.println("Owner: " + (X500Name)x509certificate.getSubjectDN() + "\n" + "Issuer: " + (X500Name)x509certificate.getIssuerDN() + "\n" + "Serial number: " + x509certificate.getSerialNumber().toString(16) + "\n" + "Valid from: " + x509certificate.getNotBefore().toString() + " until: " + x509certificate.getNotAfter().toString() + "\n" + "Certificate fingerprints:\n" + "\t MD5:  " + getCertFingerPrint("MD5", x509certificate) + "\n" + "\t SHA1: " + getCertFingerPrint("SHA1", x509certificate));
    }

    private char[] readPasswd(InputStream inputstream)
        throws IOException
    {
        char ac[];
        char ac1[] = ac = new char[128];
        int i = ac1.length;
        int j = 0;
        int k;
label0:
        do
            switch(k = inputstream.read())
            {
            case -1: 
            case 10: /* '\n' */
                break label0;

            case 13: /* '\r' */
                int l = inputstream.read();
                if(l == 10 || l == -1)
                    break label0;
                if(!(inputstream instanceof PushbackInputStream))
                    inputstream = new PushbackInputStream(inputstream);
                ((PushbackInputStream)inputstream).unread(l);
                // fall through

            default:
                if(--i < 0)
                {
                    ac1 = new char[j + 128];
                    i = ac1.length - j - 1;
                    System.arraycopy(ac, 0, ac1, 0, j);
                    Arrays.fill(ac, ' ');
                    ac = ac1;
                }
                ac1[j++] = (char)k;
                break;

            }
        while(true);
        if(j == 0)
        {
            return null;
        }
        else
        {
            char ac2[] = new char[j];
            System.arraycopy(ac1, 0, ac2, 0, j);
            Arrays.fill(ac1, ' ');
            return ac2;
        }
    }

    private Object[] recoverPrivateKey(String s, char ac[], char ac1[])
        throws Exception
    {
        Key key = null;
        if(!keyStore.containsAlias(s))
            throw new Exception("Alias <" + s + "> does not exist");
        if(!keyStore.isKeyEntry(s))
            throw new Exception("Alias <" + s + "> has no (private) key");
        if(ac1 == null)
            try
            {
                key = keyStore.getKey(s, ac);
                ac1 = ac;
            }
            catch(UnrecoverableKeyException _ex)
            {
                ac1 = getKeyPasswd(s, null, null);
                key = keyStore.getKey(s, ac1);
            }
        else
            key = keyStore.getKey(s, ac1);
        if(!(key instanceof PrivateKey))
            throw new Exception("Recovered key is not a private key");
        else
            return (new Object[] {
                (PrivateKey)key, ac1
            });
    }

    public void run(String as[], PrintStream printstream)
    {
        try
        {
         	Security.addProvider(new ABAProvider());
		parseArgs(as);
            doCommands(printstream);
        }
        catch(Exception exception1)
        {
            System.out.println("keytool error: " + exception1.getMessage());
            if(debug)
                exception1.printStackTrace();
            System.exit(1);
        }
        finally
        {
            if(storePass != null)
            {
                Arrays.fill(storePass, ' ');
                storePass = null;
            }
            if(storePassNew != null)
            {
                Arrays.fill(storePassNew, ' ');
                storePassNew = null;
            }
            if(keyPass != null)
            {
                Arrays.fill(keyPass, ' ');
                keyPass = null;
            }
            if(keyPassNew != null)
            {
                Arrays.fill(keyPassNew, ' ');
                keyPassNew = null;
            }
            if(oldPass != null)
            {
                Arrays.fill(oldPass, ' ');
                oldPass = null;
            }
            if(newPass != null)
            {
                Arrays.fill(newPass, ' ');
                newPass = null;
            }
        }
    }

    private String toHexString(byte abyte0[])
    {
        StringBuffer stringbuffer = new StringBuffer();
        int i = abyte0.length;
        for(int j = 0; j < i; j++)
        {
            byte2hex(abyte0[j], stringbuffer);
            if(j < i - 1)
                stringbuffer.append(":");
        }

        return stringbuffer.toString();
    }

    private void usage()
    {
        System.err.println("keytool usage:\n");
        System.err.print("-certreq     [-v] [-alias <alias>] ");
        System.err.println("[-sigalg <sigalg>]");
        System.err.println("\t     [-file <csr_file>] [-keypass <keypass>]");
        System.err.print("\t     [-keystore <keystore>] ");
        System.err.println("[-storepass <storepass>]");
        System.err.println("\t     [-storetype <storetype>]");
        System.err.println();
        System.err.println("-delete      [-v] -alias <alias>");
        System.err.print("\t     [-keystore <keystore>] ");
        System.err.println("[-storepass <storepass>]");
        System.err.println("\t     [-storetype <storetype>]");
        System.err.println();
        System.err.print("-export      [-v] [-rfc] [-alias <alias>] ");
        System.err.println("[-file <cert_file>]");
        System.err.print("\t     [-keystore <keystore>] ");
        System.err.println("[-storepass <storepass>]");
        System.err.println("\t     [-storetype <storetype>]");
        System.err.println();
        System.err.print("-genkey      [-v] [-alias <alias>] ");
        System.err.println("[-keyalg <keyalg>]");
        System.err.println("\t     [-keysize <keysize>] [-sigalg <sigalg>]");
        System.err.print("\t     [-dname <dname>] ");
        System.err.println("[-validity <valDays>]");
        System.err.print("\t     [-keypass <keypass>] ");
        System.err.println("[-keystore <keystore>]");
        System.err.print("\t     [-storepass <storepass>] ");
        System.err.println("[-storetype <storetype>]");
        System.err.println();
        System.err.println("-help");
        System.err.println();
        System.err.print("-identitydb  [-v] [-file <idb_file>] ");
        System.err.println("[-keystore <keystore>]");
        System.err.print("\t     [-storepass <storepass>] ");
        System.err.println("[-storetype <storetype>]");
        System.err.println();
        System.err.print("-import      [-v] [-noprompt] [-trustcacerts] ");
        System.err.println("[-alias <alias>]");
        System.err.print("\t     [-file <cert_file>] ");
        System.err.println("[-keypass <keypass>] ");
        System.err.print("\t     [-keystore <keystore>] ");
        System.err.println("[-storepass <storepass>]");
        System.err.println("\t     [-storetype <storetype>]");
        System.err.println();
        System.err.print("-keyclone    [-v] [-alias <alias>] ");
        System.err.println("-dest <dest_alias>");
        System.err.print("\t     [-keypass <keypass>] ");
        System.err.println("[-new <new_keypass>]");
        System.err.print("\t     [-keystore <keystore>] ");
        System.err.println("[-storepass <storepass>]");
        System.err.println("\t     [-storetype <storetype>]");
        System.err.println();
        System.err.println("-keypasswd   [-v] [-alias <alias>]");
        System.err.print("\t     [-keypass <old_keypass>] ");
        System.err.println("[-new <new_keypass>]");
        System.err.print("\t     [-keystore <keystore>] ");
        System.err.println("[-storepass <storepass>]");
        System.err.println("\t     [-storetype <storetype>]");
        System.err.println();
        System.err.println("-list        [-v | -rfc] [-alias <alias>]");
        System.err.print("\t     [-keystore <keystore>] ");
        System.err.println("[-storepass <storepass>]");
        System.err.println("\t     [-storetype <storetype>]");
        System.err.println();
        System.err.println("-printcert   [-v] [-file <cert_file>]");
        System.err.println();
        System.err.print("-selfcert    [-v] [-alias <alias>] ");
        System.err.println("[-sigalg <sigalg>]");
        System.err.print("\t     [-dname <dname>] ");
        System.err.println("[-validity <valDays>]");
        System.err.print("\t     [-keypass <keypass>] ");
        System.err.println("[-keystore <keystore>]");
        System.err.print("\t     [-storepass <storepass>] ");
        System.err.println("[-storetype <storetype>]");
        System.err.println();
        System.err.println("-storepasswd [-v] [-new <new_storepass>]");
        System.err.print("\t     [-keystore <keystore>] ");
        System.err.println("[-storepass <storepass>]");
        System.err.println("\t     [-storetype <storetype>]");
        System.err.println();
        System.exit(1);
    }

    private java.security.cert.Certificate[] validateReply(String s, java.security.cert.Certificate certificate, java.security.cert.Certificate acertificate[])
        throws Exception
    {
        X509Certificate ax509certificate[] = new X509Certificate[acertificate.length];
        Principal principal = null;
        int i;
        for(i = 0; i < acertificate.length; i++)
        {
            if(!isSelfSigned((X509Certificate)acertificate[i]))
                continue;
            ax509certificate[ax509certificate.length - 1] = (X509Certificate)acertificate[i];
            principal = ((X509Certificate)acertificate[i]).getSubjectDN();
            acertificate[i] = null;
            break;
        }

        if(i == acertificate.length)
            throw new Exception("No self-signed certificate in reply");
        for(int j = ax509certificate.length - 2; j >= 0; j--)
        {
            int l;
            for(l = 0; l < acertificate.length; l++)
            {
                if(acertificate[l] == null)
                    continue;
                Principal principal1 = ((X509Certificate)acertificate[l]).getIssuerDN();
                if(!principal.equals(principal1))
                    continue;
                ax509certificate[j] = (X509Certificate)acertificate[l];
                principal = ((X509Certificate)acertificate[l]).getSubjectDN();
                acertificate[l] = null;
                break;
            }

            if(l == acertificate.length)
                throw new Exception("Incomplete certificate chain in reply");
        }

        java.security.PublicKey publickey = certificate.getPublicKey();
        java.security.PublicKey publickey1 = ax509certificate[0].getPublicKey();
        if(!publickey.equals(publickey1))
        {
            String s1 = "Public key in certificate reply different from public key for <" + s + ">";
            throw new Exception(s1);
        }
        for(int k = 0; k < ax509certificate.length - 1; k++)
        {
            java.security.PublicKey publickey2 = ax509certificate[k + 1].getPublicKey();
            try
            {
                ax509certificate[k].verify(publickey2);
            }
            catch(Exception exception)
            {
                throw new Exception("Certificate chain in reply does not verify: " + exception.getMessage());
            }
        }

        if(noprompt)
            return ax509certificate;
        if(!isTrusted(ax509certificate[ax509certificate.length - 1]))
        {
            System.err.println();
            System.err.println("Root certificate in reply:\n");
            printX509Cert(ax509certificate[ax509certificate.length - 1], System.out);
            System.err.println();
            System.err.print("... is not trusted. ");
            String s2 = getYesNoReply("Install reply anyway? [no]:  ");
            if(s2.equalsIgnoreCase("YES"))
                return ax509certificate;
            else
                return null;
        }
        else
        {
            return ax509certificate;
        }
    }

    private boolean debug;
    private String command;
    private String sigAlgName;
    private String keyAlgName;
    private boolean verbose;
    private int keysize;
    private boolean rfc;
    private int validity;
    private String alias;
    private String dname;
    private String keyAlias;
    private String dest;
    private String filename;
    private String storetype;
    private char storePass[];
    private char storePassNew[];
    private char keyPass[];
    private char keyPassNew[];
    private char oldPass[];
    private char newPass[];
    private String ksfname;
    private File ksfile;
    private InputStream ksStream;
    private InputStream inStream;
    private KeyStore keyStore;
    private boolean kssave;
    private boolean noprompt;
    private boolean trustcacerts;
    private CertificateFactory cf;
}
